/* Decode header for nios16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef NIOS16BF_DECODE_H
#define NIOS16BF_DECODE_H

extern const IDESC *nios16bf_decode (SIM_CPU *, IADDR,
                                  CGEN_INSN_INT, CGEN_INSN_INT,
                                  ARGBUF *);
extern void nios16bf_init_idesc_table (SIM_CPU *);
extern void nios16bf_sem_init_idesc_table (SIM_CPU *);
extern void nios16bf_semf_init_idesc_table (SIM_CPU *);

/* Enum declaration for instructions in cpu family nios16bf.  */
typedef enum nios16bf_insn_type {
  NIOS16BF_INSN_X_INVALID, NIOS16BF_INSN_X_AFTER, NIOS16BF_INSN_X_BEFORE, NIOS16BF_INSN_X_CTI_CHAIN
 , NIOS16BF_INSN_X_CHAIN, NIOS16BF_INSN_X_BEGIN, NIOS16BF_INSN_EXT8S16, NIOS16BF_INSN_ST8S16
 , NIOS16BF_INSN_STS8S16, NIOS16BF_INSN_ST8D16, NIOS16BF_INSN_WRCTL16, NIOS16BF_INSN_ADDC16
 , NIOS16BF_INSN_SUBC16, NIOS16BF_INSN_ADD16, NIOS16BF_INSN_SUB16, NIOS16BF_INSN_ADDI16
 , NIOS16BF_INSN_SUBI16, NIOS16BF_INSN_OR16, NIOS16BF_INSN_XOR16, NIOS16BF_INSN_AND16
 , NIOS16BF_INSN_ANDN16, NIOS16BF_INSN_LSL16, NIOS16BF_INSN_LSR16, NIOS16BF_INSN_ASR16
 , NIOS16BF_INSN_LSLI16, NIOS16BF_INSN_LSRI16, NIOS16BF_INSN_ASRI16, NIOS16BF_INSN_NOT16
 , NIOS16BF_INSN_NEG16, NIOS16BF_INSN_ABS16, NIOS16BF_INSN_MOV16, NIOS16BF_INSN_MOVI16
 , NIOS16BF_INSN_BGEN16, NIOS16BF_INSN_CMP16, NIOS16BF_INSN_CMPI16,
  NIOS16BF_INSN_EXT8D16, NIOS16BF_INSN_SEXT816, NIOS16BF_INSN_FILL816, NIOS16BF_INSN_LDS16
 , NIOS16BF_INSN_STS16, NIOS16BF_INSN_LDP16, NIOS16BF_INSN_STP16, NIOS16BF_INSN_LD16
 , NIOS16BF_INSN_ST16, NIOS16BF_INSN_TRAP16, NIOS16BF_INSN_TRET16, NIOS16BF_INSN_SAVE16
 , NIOS16BF_INSN_RESTORE16, NIOS16BF_INSN_BSR16, NIOS16BF_INSN_JMP16, NIOS16BF_INSN_CALL16
 , NIOS16BF_INSN_JMPC16, NIOS16BF_INSN_CALLC16, NIOS16BF_INSN_SKP016, NIOS16BF_INSN_SKP116
 , NIOS16BF_INSN_SKPRZ16, NIOS16BF_INSN_SKPRNZ16, NIOS16BF_INSN_SKPS16, NIOS16BF_INSN_RRC16
 , NIOS16BF_INSN_RLC16, NIOS16BF_INSN_RDCTL16, NIOS16BF_INSN_PFX, NIOS16BF_INSN_BR
 , NIOS16BF_INSN_PFXIO, NIOS16BF_INSN_MAX
} NIOS16BF_INSN_TYPE;

/* Enum declaration for semantic formats in cpu family nios16bf.  */
typedef enum nios16bf_sfmt_type {
  NIOS16BF_SFMT_EMPTY, NIOS16BF_SFMT_EXT8S16, NIOS16BF_SFMT_ST8S16, NIOS16BF_SFMT_STS8S16
 , NIOS16BF_SFMT_ST8D16, NIOS16BF_SFMT_WRCTL16, NIOS16BF_SFMT_ADDC16, NIOS16BF_SFMT_ADD16
 , NIOS16BF_SFMT_ADDI16, NIOS16BF_SFMT_OR16, NIOS16BF_SFMT_LSL16, NIOS16BF_SFMT_LSLI16
 , NIOS16BF_SFMT_NOT16, NIOS16BF_SFMT_MOV16, NIOS16BF_SFMT_MOVI16, NIOS16BF_SFMT_BGEN16
 , NIOS16BF_SFMT_CMP16, NIOS16BF_SFMT_CMPI16,               NIOS16BF_SFMT_EXT8D16
 , NIOS16BF_SFMT_SEXT816, NIOS16BF_SFMT_FILL816, NIOS16BF_SFMT_LDS16, NIOS16BF_SFMT_STS16
 , NIOS16BF_SFMT_LDP16, NIOS16BF_SFMT_STP16, NIOS16BF_SFMT_LD16, NIOS16BF_SFMT_ST16
 , NIOS16BF_SFMT_TRAP16, NIOS16BF_SFMT_TRET16, NIOS16BF_SFMT_SAVE16, NIOS16BF_SFMT_RESTORE16
 , NIOS16BF_SFMT_BSR16, NIOS16BF_SFMT_JMP16, NIOS16BF_SFMT_CALL16, NIOS16BF_SFMT_JMPC16
 , NIOS16BF_SFMT_CALLC16, NIOS16BF_SFMT_SKP016, NIOS16BF_SFMT_SKPRZ16, NIOS16BF_SFMT_SKPS16
 , NIOS16BF_SFMT_RRC16, NIOS16BF_SFMT_RDCTL16, NIOS16BF_SFMT_PFX, NIOS16BF_SFMT_BR,
  NIOS16BF_SFMT_PFXIO
} NIOS16BF_SFMT_TYPE;

/* Function unit handlers (user written).  */

extern int nios16bf_model_nios16_1_u_exec (SIM_CPU *, const IDESC *, int /*unit_num*/, int /*referenced*/);

/* Profiling before/after handlers (user written) */

extern void nios16bf_model_insn_before (SIM_CPU *, int /*first_p*/);
extern void nios16bf_model_insn_after (SIM_CPU *, int /*last_p*/, int /*cycles*/);

#endif /* NIOS16BF_DECODE_H */
