/* Simulator instruction decoder for nios32bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU nios32bf
#define WANT_CPU_NIOS32BF

#include "sim-main.h"
#include "sim-assert.h"

/* The instruction descriptor array.
   This is computed at runtime.  Space for it is not malloc'd to save a
   teensy bit of cpu in the decoder.  Moving it to malloc space is trivial
   but won't be done until necessary (we don't currently support the runtime
   addition of instructions nor an SMP machine with different cpus).  */
static IDESC nios32bf_insn_data[NIOS32BF_INSN_MAX];

/* Commas between elements are contained in the macros.
   Some of these are conditionally compiled out.  */

static const struct insn_sem nios32bf_insn_sem[] =
{
  { VIRTUAL_INSN_X_INVALID, NIOS32BF_INSN_X_INVALID, NIOS32BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_AFTER, NIOS32BF_INSN_X_AFTER, NIOS32BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_BEFORE, NIOS32BF_INSN_X_BEFORE, NIOS32BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_CTI_CHAIN, NIOS32BF_INSN_X_CTI_CHAIN, NIOS32BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_CHAIN, NIOS32BF_INSN_X_CHAIN, NIOS32BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_BEGIN, NIOS32BF_INSN_X_BEGIN, NIOS32BF_SFMT_EMPTY },
  { NIOS_INSN_STS8S32, NIOS32BF_INSN_STS8S32, NIOS32BF_SFMT_STS8S32 },
  { NIOS_INSN_STS16S, NIOS32BF_INSN_STS16S, NIOS32BF_SFMT_STS16S },
  { NIOS_INSN_MOVHI, NIOS32BF_INSN_MOVHI, NIOS32BF_SFMT_MOVHI },
  { NIOS_INSN_EXT16D, NIOS32BF_INSN_EXT16D, NIOS32BF_SFMT_EXT16D },
  { NIOS_INSN_SEXT16, NIOS32BF_INSN_SEXT16, NIOS32BF_SFMT_SEXT16 },
  { NIOS_INSN_ST16D, NIOS32BF_INSN_ST16D, NIOS32BF_SFMT_ST16D },
  { NIOS_INSN_FILL16, NIOS32BF_INSN_FILL16, NIOS32BF_SFMT_FILL16 },
  { NIOS_INSN_EXT8S32, NIOS32BF_INSN_EXT8S32, NIOS32BF_SFMT_EXT8S32 },
  { NIOS_INSN_ST8S32, NIOS32BF_INSN_ST8S32, NIOS32BF_SFMT_ST8S32 },
  { NIOS_INSN_EXT16S, NIOS32BF_INSN_EXT16S, NIOS32BF_SFMT_EXT16S },
  { NIOS_INSN_ST16S, NIOS32BF_INSN_ST16S, NIOS32BF_SFMT_ST16S },
  { NIOS_INSN_ST8D32, NIOS32BF_INSN_ST8D32, NIOS32BF_SFMT_ST8D32 },
  { NIOS_INSN_WRCTL32, NIOS32BF_INSN_WRCTL32, NIOS32BF_SFMT_WRCTL32 },
  { NIOS_INSN_ADD32, NIOS32BF_INSN_ADD32, NIOS32BF_SFMT_ADD32 },
  { NIOS_INSN_SUB32, NIOS32BF_INSN_SUB32, NIOS32BF_SFMT_ADD32 },
  { NIOS_INSN_ADDI32, NIOS32BF_INSN_ADDI32, NIOS32BF_SFMT_ADDI32 },
  { NIOS_INSN_SUBI32, NIOS32BF_INSN_SUBI32, NIOS32BF_SFMT_ADDI32 },
  { NIOS_INSN_OR32, NIOS32BF_INSN_OR32, NIOS32BF_SFMT_OR32 },
  { NIOS_INSN_XOR32, NIOS32BF_INSN_XOR32, NIOS32BF_SFMT_OR32 },
  { NIOS_INSN_AND32, NIOS32BF_INSN_AND32, NIOS32BF_SFMT_OR32 },
  { NIOS_INSN_ANDN32, NIOS32BF_INSN_ANDN32, NIOS32BF_SFMT_OR32 },
  { NIOS_INSN_LSL32, NIOS32BF_INSN_LSL32, NIOS32BF_SFMT_LSL32 },
  { NIOS_INSN_LSR32, NIOS32BF_INSN_LSR32, NIOS32BF_SFMT_LSL32 },
  { NIOS_INSN_ASR32, NIOS32BF_INSN_ASR32, NIOS32BF_SFMT_LSL32 },
  { NIOS_INSN_LSLI32, NIOS32BF_INSN_LSLI32, NIOS32BF_SFMT_LSLI32 },
  { NIOS_INSN_LSRI32, NIOS32BF_INSN_LSRI32, NIOS32BF_SFMT_LSLI32 },
  { NIOS_INSN_ASRI32, NIOS32BF_INSN_ASRI32, NIOS32BF_SFMT_LSLI32 },
  { NIOS_INSN_NOT32, NIOS32BF_INSN_NOT32, NIOS32BF_SFMT_NOT32 },
  { NIOS_INSN_NEG32, NIOS32BF_INSN_NEG32, NIOS32BF_SFMT_NOT32 },
  { NIOS_INSN_ABS32, NIOS32BF_INSN_ABS32, NIOS32BF_SFMT_NOT32 },
  { NIOS_INSN_MOV32, NIOS32BF_INSN_MOV32, NIOS32BF_SFMT_MOV32 },
  { NIOS_INSN_MOVI32, NIOS32BF_INSN_MOVI32, NIOS32BF_SFMT_MOVI32 },
  { NIOS_INSN_BGEN32, NIOS32BF_INSN_BGEN32, NIOS32BF_SFMT_BGEN32 },
  { NIOS_INSN_CMP32, NIOS32BF_INSN_CMP32, NIOS32BF_SFMT_CMP32 },
  { NIOS_INSN_CMPI32, NIOS32BF_INSN_CMPI32, NIOS32BF_SFMT_CMPI32 },
//  { NIOS_INSN_LDC32, NIOS32BF_INSN_LDC32, NIOS32BF_SFMT_LDC32 },
  { NIOS_INSN_EXT8D32, NIOS32BF_INSN_EXT8D32, NIOS32BF_SFMT_EXT16D },
  { NIOS_INSN_SEXT832, NIOS32BF_INSN_SEXT832, NIOS32BF_SFMT_SEXT16 },
  { NIOS_INSN_FILL832, NIOS32BF_INSN_FILL832, NIOS32BF_SFMT_FILL16 },
  { NIOS_INSN_LDS32, NIOS32BF_INSN_LDS32, NIOS32BF_SFMT_LDS32 },
  { NIOS_INSN_STS32, NIOS32BF_INSN_STS32, NIOS32BF_SFMT_STS32 },
  { NIOS_INSN_LDP32, NIOS32BF_INSN_LDP32, NIOS32BF_SFMT_LDP32 },
  { NIOS_INSN_STP32, NIOS32BF_INSN_STP32, NIOS32BF_SFMT_STP32 },
  { NIOS_INSN_LD32, NIOS32BF_INSN_LD32, NIOS32BF_SFMT_LD32 },
  { NIOS_INSN_ST32, NIOS32BF_INSN_ST32, NIOS32BF_SFMT_ST32 },
  { NIOS_INSN_TRAP32, NIOS32BF_INSN_TRAP32, NIOS32BF_SFMT_TRAP32 },
  { NIOS_INSN_TRET32, NIOS32BF_INSN_TRET32, NIOS32BF_SFMT_TRET32 },
  { NIOS_INSN_SAVE32, NIOS32BF_INSN_SAVE32, NIOS32BF_SFMT_SAVE32 },
  { NIOS_INSN_RESTORE32, NIOS32BF_INSN_RESTORE32, NIOS32BF_SFMT_RESTORE32 },
  { NIOS_INSN_BSR32, NIOS32BF_INSN_BSR32, NIOS32BF_SFMT_BSR32 },
  { NIOS_INSN_JMP32, NIOS32BF_INSN_JMP32, NIOS32BF_SFMT_JMP32 },
  { NIOS_INSN_CALL32, NIOS32BF_INSN_CALL32, NIOS32BF_SFMT_CALL32 },
  { NIOS_INSN_JMPC32, NIOS32BF_INSN_JMPC32, NIOS32BF_SFMT_JMPC32 },
  { NIOS_INSN_CALLC32, NIOS32BF_INSN_CALLC32, NIOS32BF_SFMT_CALLC32 },
  { NIOS_INSN_SKP032, NIOS32BF_INSN_SKP032, NIOS32BF_SFMT_SKP032 },
  { NIOS_INSN_SKP132, NIOS32BF_INSN_SKP132, NIOS32BF_SFMT_SKP032 },
  { NIOS_INSN_SKPRZ32, NIOS32BF_INSN_SKPRZ32, NIOS32BF_SFMT_SKPRZ32 },
  { NIOS_INSN_SKPRNZ32, NIOS32BF_INSN_SKPRNZ32, NIOS32BF_SFMT_SKPRZ32 },
  { NIOS_INSN_SKPS32, NIOS32BF_INSN_SKPS32, NIOS32BF_SFMT_SKPS32 },
  { NIOS_INSN_RRC32, NIOS32BF_INSN_RRC32, NIOS32BF_SFMT_RRC32 },
  { NIOS_INSN_RLC32, NIOS32BF_INSN_RLC32, NIOS32BF_SFMT_RRC32 },
  { NIOS_INSN_RDCTL32, NIOS32BF_INSN_RDCTL32, NIOS32BF_SFMT_RDCTL32 },
  { NIOS_INSN_PFX, NIOS32BF_INSN_PFX, NIOS32BF_SFMT_PFX },
  { NIOS_INSN_BR, NIOS32BF_INSN_BR, NIOS32BF_SFMT_BR },
};

static const struct insn_sem nios32bf_insn_sem_invalid = {
  VIRTUAL_INSN_X_INVALID, NIOS32BF_INSN_X_INVALID, NIOS32BF_SFMT_EMPTY
};

/* Initialize an IDESC from the compile-time computable parts.  */

static INLINE void
init_idesc (SIM_CPU *cpu, IDESC *id, const struct insn_sem *t)
{
  const CGEN_INSN *insn_table = CGEN_CPU_INSN_TABLE (CPU_CPU_DESC (cpu))->init_entries;

  id->num = t->index;
  id->sfmt = t->sfmt;
  if ((int) t->type <= 0)
    id->idata = & cgen_virtual_insn_table[- (int) t->type];
  else
    id->idata = & insn_table[t->type];
  id->attrs = CGEN_INSN_ATTRS (id->idata);
  /* Oh my god, a magic number.  */
  id->length = CGEN_INSN_BITSIZE (id->idata) / 8;

#if WITH_PROFILE_MODEL_P
  id->timing = & MODEL_TIMING (CPU_MODEL (cpu)) [t->index];
  {
    SIM_DESC sd = CPU_STATE (cpu);
    SIM_ASSERT (t->index == id->timing->num);
  }
#endif

  /* Semantic pointers are initialized elsewhere.  */
}

/* Initialize the instruction descriptor table.  */

void
nios32bf_init_idesc_table (SIM_CPU *cpu)
{
  IDESC *id,*tabend;
  const struct insn_sem *t,*tend;
  int tabsize = NIOS32BF_INSN_MAX;
  IDESC *table = nios32bf_insn_data;

  memset (table, 0, tabsize * sizeof (IDESC));

  /* First set all entries to the `invalid insn'.  */
  t = & nios32bf_insn_sem_invalid;
  for (id = table, tabend = table + tabsize; id < tabend; ++id)
    init_idesc (cpu, id, t);

  /* Now fill in the values for the chosen cpu.  */
  for (t = nios32bf_insn_sem, tend = t + sizeof (nios32bf_insn_sem) / sizeof (*t);
       t != tend; ++t)
    {
      init_idesc (cpu, & table[t->index], t);
    }

  /* Link the IDESC table into the cpu.  */
  CPU_IDESC (cpu) = table;
}

/* Given an instruction, return a pointer to its IDESC entry.  */

const IDESC *
nios32bf_decode (SIM_CPU *current_cpu, IADDR pc,
              CGEN_INSN_INT base_insn, CGEN_INSN_INT entire_insn,
              ARGBUF *abuf)
{
  /* Result of decoder.  */
  NIOS32BF_INSN_TYPE itype;

  {
    CGEN_INSN_INT insn = base_insn;

    {
      unsigned int val = (((insn >> 10) & (63 << 0)));
      switch (val)
      {
      case 0 : itype = NIOS32BF_INSN_ADD32; goto extract_sfmt_add32;
      case 1 : itype = NIOS32BF_INSN_ADDI32; goto extract_sfmt_addi32;
      case 2 : itype = NIOS32BF_INSN_SUB32; goto extract_sfmt_add32;
      case 3 : itype = NIOS32BF_INSN_SUBI32; goto extract_sfmt_addi32;
      case 4 : itype = NIOS32BF_INSN_CMP32; goto extract_sfmt_cmp32;
      case 5 : itype = NIOS32BF_INSN_CMPI32; goto extract_sfmt_cmpi32;
      case 6 : itype = NIOS32BF_INSN_LSL32; goto extract_sfmt_lsl32;
      case 7 : itype = NIOS32BF_INSN_LSLI32; goto extract_sfmt_lsli32;
      case 8 : itype = NIOS32BF_INSN_LSR32; goto extract_sfmt_lsl32;
      case 9 : itype = NIOS32BF_INSN_LSRI32; goto extract_sfmt_lsli32;
      case 10 : itype = NIOS32BF_INSN_ASR32; goto extract_sfmt_lsl32;
      case 11 : itype = NIOS32BF_INSN_ASRI32; goto extract_sfmt_lsli32;
      case 12 : itype = NIOS32BF_INSN_MOV32; goto extract_sfmt_mov32;
      case 13 : itype = NIOS32BF_INSN_MOVI32; goto extract_sfmt_movi32;
      case 14 : itype = NIOS32BF_INSN_AND32; goto extract_sfmt_or32;
      case 15 : itype = NIOS32BF_INSN_ANDN32; goto extract_sfmt_or32;
      case 16 : itype = NIOS32BF_INSN_OR32; goto extract_sfmt_or32;
      case 17 : itype = NIOS32BF_INSN_XOR32; goto extract_sfmt_or32;
      case 18 : itype = NIOS32BF_INSN_BGEN32; goto extract_sfmt_bgen32;
      case 19 : itype = NIOS32BF_INSN_EXT8D32; goto extract_sfmt_ext16d;
      case 20 : itype = NIOS32BF_INSN_SKP032; goto extract_sfmt_skp032;
      case 21 : itype = NIOS32BF_INSN_SKP132; goto extract_sfmt_skp032;
      case 22 : itype = NIOS32BF_INSN_LD32; goto extract_sfmt_ld32;
      case 23 : itype = NIOS32BF_INSN_ST32; goto extract_sfmt_st32;
      case 24 : itype = NIOS32BF_INSN_STS8S32; goto extract_sfmt_sts8s32;
      case 25 : itype = NIOS32BF_INSN_STS16S; goto extract_sfmt_sts16s;
      case 26 : itype = NIOS32BF_INSN_EXT16D; goto extract_sfmt_ext16d;
      case 27 : itype = NIOS32BF_INSN_MOVHI; goto extract_sfmt_movhi;
      case 29 :
        {
          unsigned int val = (((insn >> 7) & (7 << 0)));
          switch (val)
          {
          case 0 : itype = NIOS32BF_INSN_EXT8S32; goto extract_sfmt_ext8s32;
          case 1 : itype = NIOS32BF_INSN_EXT16S; goto extract_sfmt_ext16s;
          case 4 : itype = NIOS32BF_INSN_ST8S32; goto extract_sfmt_st8s32;
          case 5 : itype = NIOS32BF_INSN_ST16S; goto extract_sfmt_st16s;
          default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
          }
        }
      case 30 :
        {
          unsigned int val = (((insn >> 8) & (3 << 0)));
          switch (val)
          {
          case 0 : itype = NIOS32BF_INSN_SAVE32; goto extract_sfmt_save32;
          case 1 : itype = NIOS32BF_INSN_TRAP32; goto extract_sfmt_trap32;
          case 2 : itype = NIOS32BF_INSN_JMPC32; goto extract_sfmt_jmpc32;
          case 3 : itype = NIOS32BF_INSN_CALLC32; goto extract_sfmt_callc32;
          default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
          }
        }
      case 31 :
        {
          unsigned int val = (((insn >> 6) & (15 << 0)));
          switch (val)
          {
          case 0 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_NOT32; goto extract_sfmt_not32;
              case 1 : itype = NIOS32BF_INSN_NEG32; goto extract_sfmt_not32;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 1 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_ABS32; goto extract_sfmt_not32;
              case 1 : itype = NIOS32BF_INSN_SEXT832; goto extract_sfmt_sext16;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 2 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_SEXT16; goto extract_sfmt_sext16;
              case 1 : itype = NIOS32BF_INSN_RLC32; goto extract_sfmt_rrc32;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 3 : itype = NIOS32BF_INSN_RRC32; goto extract_sfmt_rrc32;
          case 6 : itype = NIOS32BF_INSN_RESTORE32; goto extract_sfmt_restore32;
          case 7 : itype = NIOS32BF_INSN_TRET32; goto extract_sfmt_tret32;
          case 8 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_ST8D32; goto extract_sfmt_st8d32;
              case 1 : itype = NIOS32BF_INSN_ST16D; goto extract_sfmt_st16d;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 9 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_FILL832; goto extract_sfmt_fill16;
              case 1 : itype = NIOS32BF_INSN_FILL16; goto extract_sfmt_fill16;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 11 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_SKPRZ32; goto extract_sfmt_skprz32;
              case 1 : itype = NIOS32BF_INSN_SKPS32; goto extract_sfmt_skps32;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 12 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_WRCTL32; goto extract_sfmt_wrctl32;
              case 1 : itype = NIOS32BF_INSN_RDCTL32; goto extract_sfmt_rdctl32;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 13 : itype = NIOS32BF_INSN_SKPRNZ32; goto extract_sfmt_skprz32;
          case 15 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS32BF_INSN_JMP32; goto extract_sfmt_jmp32;
              case 1 : itype = NIOS32BF_INSN_CALL32; goto extract_sfmt_call32;
              default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
          }
        }
      case 32 : /* fall through */
      case 33 : itype = NIOS32BF_INSN_BR; goto extract_sfmt_br;
      case 34 : /* fall through */
      case 35 : itype = NIOS32BF_INSN_BSR32; goto extract_sfmt_bsr32;
      case 36 : /* fall through */
//JMB      case 37 : itype = NIOS32BF_INSN_LDC32; goto extract_sfmt_ldc32;
      case 37 : itype = NIOS32BF_INSN_PFXIO; goto extract_sfmt_pfx;
      case 38 : /* fall through */
      case 39 : itype = NIOS32BF_INSN_PFX; goto extract_sfmt_pfx;
      case 40 : /* fall through */
      case 41 : /* fall through */
      case 42 : /* fall through */
      case 43 : itype = NIOS32BF_INSN_STP32; goto extract_sfmt_stp32;
      case 44 : /* fall through */
      case 45 : /* fall through */
      case 46 : /* fall through */
      case 47 : itype = NIOS32BF_INSN_LDP32; goto extract_sfmt_ldp32;
      case 48 : /* fall through */
      case 49 : /* fall through */
      case 50 : /* fall through */
      case 51 : /* fall through */
      case 52 : /* fall through */
      case 53 : /* fall through */
      case 54 : /* fall through */
      case 55 : itype = NIOS32BF_INSN_STS32; goto extract_sfmt_sts32;
      case 56 : /* fall through */
      case 57 : /* fall through */
      case 58 : /* fall through */
      case 59 : /* fall through */
      case 60 : /* fall through */
      case 61 : /* fall through */
      case 62 : /* fall through */
      case 63 : itype = NIOS32BF_INSN_LDS32; goto extract_sfmt_lds32;
      default : itype = NIOS32BF_INSN_X_INVALID; goto extract_sfmt_empty;
      }
    }
  }

  /* The instruction has been decoded, now extract the fields.  */

 extract_sfmt_empty:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_empty", (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_sts8s32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_sts8s32.f
    UINT f_i10;

    f_i10 = EXTRACT_LSB0_UINT (insn, 16, 9, 10);

  /* Record the fields for the semantic handler.  */
  FLD (f_i10) = f_i10;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_sts8s32", "f_i10 0x%x", 'x', f_i10, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_sts16s:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_sts16s.f
    UINT f_i9;

    f_i9 = EXTRACT_LSB0_UINT (insn, 16, 9, 9);

  /* Record the fields for the semantic handler.  */
  FLD (f_i9) = f_i9;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_sts16s", "f_i9 0x%x", 'x', f_i9, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_movhi:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_movhi", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_ext16d:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16d.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ext16d", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_sext16:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_sext16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_st16d:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st16d", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_fill16:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_fill16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_ext8s32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext8s32.f
    UINT f_i2;
    UINT f_Ra;

    f_i2 = EXTRACT_LSB0_UINT (insn, 16, 6, 2);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i2) = f_i2;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ext8s32", "f_i2 0x%x", 'x', f_i2, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_st8s32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext8s32.f
    UINT f_i2;
    UINT f_Ra;

    f_i2 = EXTRACT_LSB0_UINT (insn, 16, 6, 2);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i2) = f_i2;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st8s32", "f_i2 0x%x", 'x', f_i2, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_ext16s:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16s.f
    USI f_i1;
    UINT f_Ra;

    f_i1 = ((unsigned int) (EXTRACT_LSB0_UINT (insn, 16, 6, 2)) >> (1));
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i1) = f_i1;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ext16s", "f_i1 0x%x", 'x', f_i1, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_st16s:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16s.f
    USI f_i1;
    UINT f_Ra;

    f_i1 = ((unsigned int) (EXTRACT_LSB0_UINT (insn, 16, 6, 2)) >> (1));
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i1) = f_i1;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st16s", "f_i1 0x%x", 'x', f_i1, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_st8d32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st8d32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_wrctl32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_wrctl32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_add32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16d.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_add32", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_addi32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_addi32", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_or32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_or32.f
    UINT f_Rbi5;
    UINT f_Ra;

    f_Rbi5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Rbi5) = f_Rbi5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_or32", "f_Rbi5 0x%x", 'x', f_Rbi5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_lsl32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16d.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_lsl32", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_lsli32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_lsli32", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_not32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_not32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_mov32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16d.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Rb) = f_Rb;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_mov32", "f_Rb 0x%x", 'x', f_Rb, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_movi32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_movi32", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_bgen32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_bgen32", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_cmp32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16d.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_cmp32", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_cmpi32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_cmpi32", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_ldc32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldc32.f
    USI f_i6_rel_w;
    UINT f_Ra;

    f_i6_rel_w = ((((EXTRACT_LSB0_UINT (insn, 16, 10, 6)) << (2))) + (((((pc) & (0xfffffffc))) + (4))));
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (i_m32_i6) = f_i6_rel_w;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ldc32", "f_Ra 0x%x", 'x', f_Ra, "m32_i6 0x%x", 'x', f_i6_rel_w, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_lds32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_i8;
    UINT f_Ra;

    f_i8 = EXTRACT_LSB0_UINT (insn, 16, 12, 8);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i8) = f_i8;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_lds32", "f_i8 0x%x", 'x', f_i8, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_sts32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_i8;
    UINT f_Ra;

    f_i8 = EXTRACT_LSB0_UINT (insn, 16, 12, 8);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i8) = f_i8;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_sts32", "f_i8 0x%x", 'x', f_i8, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_ldp32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_Rp;
    UINT f_i5;
    UINT f_Ra;

    f_Rp = EXTRACT_LSB0_UINT (insn, 16, 11, 2);
    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Rp) = f_Rp;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ldp32", "f_i5 0x%x", 'x', f_i5, "f_Rp 0x%x", 'x', f_Rp, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_stp32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_Rp;
    UINT f_i5;
    UINT f_Ra;

    f_Rp = EXTRACT_LSB0_UINT (insn, 16, 11, 2);
    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  FLD (f_Rp) = f_Rp;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_stp32", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, "f_Rp 0x%x", 'x', f_Rp, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_ld32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16d.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Rb) = f_Rb;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ld32", "f_Rb 0x%x", 'x', f_Rb, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_st32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext16d.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st32", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_trap32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_trap32.f
    UINT f_i6v;

    f_i6v = EXTRACT_LSB0_UINT (insn, 16, 5, 6);

  /* Record the fields for the semantic handler.  */
  FLD (f_i6v) = f_i6v;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_trap32", "f_i6v 0x%x", 'x', f_i6v, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_tret32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_tret32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_save32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_save32.f
    UINT f_i8v;

    f_i8v = EXTRACT_LSB0_UINT (insn, 16, 7, 8);

  /* Record the fields for the semantic handler.  */
  FLD (f_i8v) = f_i8v;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_save32", "f_i8v 0x%x", 'x', f_i8v, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_restore32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_restore32", (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_bsr32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_bsr32.f
    USI f_i11_rel;

    f_i11_rel = ((((((EXTRACT_LSB0_INT (insn, 16, 10, 11)) << (1))) + (pc))) + (2));

  /* Record the fields for the semantic handler.  */
  FLD (i_rel11) = f_i11_rel;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_bsr32", "rel11 0x%x", 'x', f_i11_rel, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_jmp32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_jmp32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_call32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_call32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_jmpc32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_jmpc32.f
    USI f_i8v_rel_w;

    f_i8v_rel_w = ((((((EXTRACT_LSB0_UINT (insn, 16, 7, 8)) << (1))) + (((pc) + (2))))) & (0xfffffffc));

  /* Record the fields for the semantic handler.  */
  FLD (i_m32_i8v) = f_i8v_rel_w;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_jmpc32", "m32_i8v 0x%x", 'x', f_i8v_rel_w, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_callc32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_jmpc32.f
    USI f_i8v_rel_w;

    f_i8v_rel_w = ((((((EXTRACT_LSB0_UINT (insn, 16, 7, 8)) << (1))) + (((pc) + (2))))) & (0xfffffffc));

  /* Record the fields for the semantic handler.  */
  FLD (i_m32_i8v) = f_i8v_rel_w;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_callc32", "m32_i8v 0x%x", 'x', f_i8v_rel_w, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_skp032:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp32.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_skp032", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_skprz32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_skprz32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_skps32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_skps32.f
    UINT f_i4w;

    f_i4w = EXTRACT_LSB0_UINT (insn, 16, 3, 4);

  /* Record the fields for the semantic handler.  */
  FLD (f_i4w) = f_i4w;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_skps32", "f_i4w 0x%x", 'x', f_i4w, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_rrc32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_rrc32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_rdctl32:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds32.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_rdctl32", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_pfx:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_pfx.f
    UINT f_i11;

    f_i11 = EXTRACT_LSB0_UINT (insn, 16, 10, 11);

  /* Record the fields for the semantic handler.  */
  FLD (f_i11) = f_i11;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_pfx", "f_i11 0x%x", 'x', f_i11, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_br:
  {
    const IDESC *idesc = &nios32bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_bsr32.f
    USI f_i11_rel;

    f_i11_rel = ((((((EXTRACT_LSB0_INT (insn, 16, 10, 11)) << (1))) + (pc))) + (2));

  /* Record the fields for the semantic handler.  */
  FLD (i_rel11) = f_i11_rel;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_br", "rel11 0x%x", 'x', f_i11_rel, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

}
