/* Simulator model support for nios16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU nios16bf
#define WANT_CPU_NIOS16BF

#include "sim-main.h"

/* The profiling data is recorded here, but is accessed via the profiling
   mechanism.  After all, this is information for profiling.  */

#if WITH_PROFILE_MODEL_P

/* Model handlers for each insn.  */

static int
model_nios16_1_ext8s16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext8s16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_st8s16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext8s16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_sts8s16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_sts8s16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_st8d16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_wrctl16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_addc16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_subc16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_add16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_sub16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_addi16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_subi16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_or16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_xor16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_and16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_andn16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_lsl16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_lsr16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_asr16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_lsli16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_lsri16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_asri16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_not16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_neg16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_abs16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_mov16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_movi16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_bgen16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_cmp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_cmpi16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_ldc16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_ext8d16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_sext816 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_fill816 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_lds16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_sts16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_ldp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_stp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_ld16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_st16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_addc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_trap16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_trap16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_tret16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_save16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_save16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_restore16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_bsr16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsr16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_jmp16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_call16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_jmpc16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_jmpc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_callc16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_jmpc16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_skp016 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_skp116 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_skprz16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_skprnz16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_skps16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_skps16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_rrc16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_rlc16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_rdctl16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_pfx (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_pfx.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios16_1_br (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsr16.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios16bf_model_nios16_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

/* We assume UNIT_NONE == 0 because the tables don't always terminate
   entries with it.  */

/* Model timing data for `nios16-1'.  */

static const INSN_TIMING nios16_1_timing[] = {
  { NIOS16BF_INSN_X_INVALID, 0, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_X_AFTER, 0, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_X_BEFORE, 0, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_X_CTI_CHAIN, 0, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_X_CHAIN, 0, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_X_BEGIN, 0, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_EXT8S16, model_nios16_1_ext8s16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ST8S16, model_nios16_1_st8s16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_STS8S16, model_nios16_1_sts8s16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ST8D16, model_nios16_1_st8d16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_WRCTL16, model_nios16_1_wrctl16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ADDC16, model_nios16_1_addc16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SUBC16, model_nios16_1_subc16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ADD16, model_nios16_1_add16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SUB16, model_nios16_1_sub16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ADDI16, model_nios16_1_addi16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SUBI16, model_nios16_1_subi16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_OR16, model_nios16_1_or16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_XOR16, model_nios16_1_xor16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_AND16, model_nios16_1_and16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ANDN16, model_nios16_1_andn16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_LSL16, model_nios16_1_lsl16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_LSR16, model_nios16_1_lsr16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ASR16, model_nios16_1_asr16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_LSLI16, model_nios16_1_lsli16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_LSRI16, model_nios16_1_lsri16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ASRI16, model_nios16_1_asri16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_NOT16, model_nios16_1_not16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_NEG16, model_nios16_1_neg16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ABS16, model_nios16_1_abs16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_MOV16, model_nios16_1_mov16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_MOVI16, model_nios16_1_movi16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_BGEN16, model_nios16_1_bgen16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_CMP16, model_nios16_1_cmp16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_CMPI16, model_nios16_1_cmpi16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
//  { NIOS16BF_INSN_LDC16, model_nios16_1_ldc16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_EXT8D16, model_nios16_1_ext8d16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SEXT816, model_nios16_1_sext816, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_FILL816, model_nios16_1_fill816, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_LDS16, model_nios16_1_lds16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_STS16, model_nios16_1_sts16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_LDP16, model_nios16_1_ldp16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_STP16, model_nios16_1_stp16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_LD16, model_nios16_1_ld16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_ST16, model_nios16_1_st16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_TRAP16, model_nios16_1_trap16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_TRET16, model_nios16_1_tret16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SAVE16, model_nios16_1_save16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_RESTORE16, model_nios16_1_restore16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_BSR16, model_nios16_1_bsr16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_JMP16, model_nios16_1_jmp16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_CALL16, model_nios16_1_call16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_JMPC16, model_nios16_1_jmpc16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_CALLC16, model_nios16_1_callc16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SKP016, model_nios16_1_skp016, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SKP116, model_nios16_1_skp116, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SKPRZ16, model_nios16_1_skprz16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SKPRNZ16, model_nios16_1_skprnz16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_SKPS16, model_nios16_1_skps16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_RRC16, model_nios16_1_rrc16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_RLC16, model_nios16_1_rlc16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_RDCTL16, model_nios16_1_rdctl16, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_PFX, model_nios16_1_pfx, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_BR, model_nios16_1_br, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
  { NIOS16BF_INSN_PFXIO, model_nios16_1_pfx, { { (int) UNIT_NIOS16_1_U_EXEC, 1, 1 } } },
};

#endif /* WITH_PROFILE_MODEL_P */

static void
nios16_1_model_init (SIM_CPU *cpu)
{
  CPU_MODEL_DATA (cpu) = (void *) zalloc (sizeof (MODEL_NIOS16_1_DATA));
}

#if WITH_PROFILE_MODEL_P
#define TIMING_DATA(td) td
#else
#define TIMING_DATA(td) 0
#endif

static const MODEL nios16_models[] =
{
  { "nios16-1", & nios16_mach, MODEL_NIOS16_1, TIMING_DATA (& nios16_1_timing[0]), nios16_1_model_init },
  { 0 }
};

/* The properties of this cpu's implementation.  */

static const MACH_IMP_PROPERTIES nios16bf_imp_properties =
{
  sizeof (SIM_CPU),
#if WITH_SCACHE
  sizeof (SCACHE)
#else
  0
#endif
};


static void
nios16bf_prepare_run (SIM_CPU *cpu)
{
  if (CPU_IDESC (cpu) == NULL)
    nios16bf_init_idesc_table (cpu);
}

static const CGEN_INSN *
nios16bf_get_idata (SIM_CPU *cpu, int inum)
{
  return CPU_IDESC (cpu) [inum].idata;
}

static void
nios16_init_cpu (SIM_CPU *cpu)
{
  CPU_REG_FETCH (cpu) = nios16bf_fetch_register;
  CPU_REG_STORE (cpu) = nios16bf_store_register;
  CPU_PC_FETCH (cpu) = nios16bf_h_pc_get;
  CPU_PC_STORE (cpu) = nios16bf_h_pc_set;
  CPU_GET_IDATA (cpu) = nios16bf_get_idata;
  CPU_MAX_INSNS (cpu) = NIOS16BF_INSN_MAX;
  CPU_INSN_NAME (cpu) = cgen_insn_name;
  CPU_FULL_ENGINE_FN (cpu) = nios16bf_engine_run_full;
#if WITH_FAST
  CPU_FAST_ENGINE_FN (cpu) = nios16bf_engine_run_fast;
#else
  CPU_FAST_ENGINE_FN (cpu) = nios16bf_engine_run_full;
#endif
}

const MACH nios16_mach =
{
  "nios16", "nios16", MACH_NIOS16,
  16, 16, & nios16_models[0], & nios16bf_imp_properties,
  nios16_init_cpu,
  nios16bf_prepare_run
};

