/* Simulator model support for nios32bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU nios32bf
#define WANT_CPU_NIOS32BF

#include "sim-main.h"

/* The profiling data is recorded here, but is accessed via the profiling
   mechanism.  After all, this is information for profiling.  */

#if WITH_PROFILE_MODEL_P

/* Model handlers for each insn.  */

static int
model_nios32_1_sts8s32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_sts8s32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_sts16s (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_sts16s.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_movhi (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_ext16d (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_sext16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_st16d (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_fill16 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_ext8s32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext8s32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_st8s32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext8s32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_ext16s (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16s.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_st16s (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16s.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_st8d32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_wrctl32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_add32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_sub32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_addi32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_subi32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_or32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_xor32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_and32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_andn32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_lsl32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_lsr32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_asr32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_lsli32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_lsri32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_asri32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_not32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_neg32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_abs32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_mov32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_movi32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_bgen32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_cmp32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_cmpi32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_ldc32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldc32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_ext8d32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_sext832 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_fill832 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_lds32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_sts32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_ldp32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_stp32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_ld32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_st32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_trap32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_trap32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_tret32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_save32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_save32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_restore32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_bsr32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsr32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_jmp32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_call32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_jmpc32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_jmpc32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_callc32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_jmpc32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_skp032 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_skp132 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_skprz32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_skprnz32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_skps32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_skps32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_rrc32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_rlc32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_rdctl32 (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_pfx (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_pfx.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

static int
model_nios32_1_br (SIM_CPU *current_cpu, void *sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsr32.f
  const ARGBUF * UNUSED abuf = SEM_ARGBUF ((SEM_ARG) sem_arg);
  const IDESC * UNUSED idesc = abuf->idesc;
  int cycles = 0;
  {
    int referenced = 0;
    int UNUSED insn_referenced = abuf->written;
    cycles += nios32bf_model_nios32_1_u_exec (current_cpu, idesc, 0, referenced);
  }
  return cycles;
#undef FLD
}

/* We assume UNIT_NONE == 0 because the tables don't always terminate
   entries with it.  */

/* Model timing data for `nios32-1'.  */

static const INSN_TIMING nios32_1_timing[] = {
  { NIOS32BF_INSN_X_INVALID, 0, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_X_AFTER, 0, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_X_BEFORE, 0, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_X_CTI_CHAIN, 0, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_X_CHAIN, 0, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_X_BEGIN, 0, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_STS8S32, model_nios32_1_sts8s32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_STS16S, model_nios32_1_sts16s, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_MOVHI, model_nios32_1_movhi, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_EXT16D, model_nios32_1_ext16d, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SEXT16, model_nios32_1_sext16, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ST16D, model_nios32_1_st16d, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_FILL16, model_nios32_1_fill16, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_EXT8S32, model_nios32_1_ext8s32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ST8S32, model_nios32_1_st8s32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_EXT16S, model_nios32_1_ext16s, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ST16S, model_nios32_1_st16s, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ST8D32, model_nios32_1_st8d32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_WRCTL32, model_nios32_1_wrctl32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ADD32, model_nios32_1_add32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SUB32, model_nios32_1_sub32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ADDI32, model_nios32_1_addi32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SUBI32, model_nios32_1_subi32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_OR32, model_nios32_1_or32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_XOR32, model_nios32_1_xor32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_AND32, model_nios32_1_and32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ANDN32, model_nios32_1_andn32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_LSL32, model_nios32_1_lsl32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_LSR32, model_nios32_1_lsr32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ASR32, model_nios32_1_asr32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_LSLI32, model_nios32_1_lsli32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_LSRI32, model_nios32_1_lsri32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ASRI32, model_nios32_1_asri32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_NOT32, model_nios32_1_not32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_NEG32, model_nios32_1_neg32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ABS32, model_nios32_1_abs32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_MOV32, model_nios32_1_mov32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_MOVI32, model_nios32_1_movi32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_BGEN32, model_nios32_1_bgen32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_CMP32, model_nios32_1_cmp32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_CMPI32, model_nios32_1_cmpi32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
//  { NIOS32BF_INSN_LDC32, model_nios32_1_ldc32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_EXT8D32, model_nios32_1_ext8d32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SEXT832, model_nios32_1_sext832, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_FILL832, model_nios32_1_fill832, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_LDS32, model_nios32_1_lds32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_STS32, model_nios32_1_sts32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_LDP32, model_nios32_1_ldp32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_STP32, model_nios32_1_stp32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_LD32, model_nios32_1_ld32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_ST32, model_nios32_1_st32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_TRAP32, model_nios32_1_trap32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_TRET32, model_nios32_1_tret32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SAVE32, model_nios32_1_save32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_RESTORE32, model_nios32_1_restore32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_BSR32, model_nios32_1_bsr32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_JMP32, model_nios32_1_jmp32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_CALL32, model_nios32_1_call32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_JMPC32, model_nios32_1_jmpc32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_CALLC32, model_nios32_1_callc32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SKP032, model_nios32_1_skp032, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SKP132, model_nios32_1_skp132, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SKPRZ32, model_nios32_1_skprz32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SKPRNZ32, model_nios32_1_skprnz32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_SKPS32, model_nios32_1_skps32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_RRC32, model_nios32_1_rrc32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_RLC32, model_nios32_1_rlc32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_RDCTL32, model_nios32_1_rdctl32, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_PFX, model_nios32_1_pfx, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_BR, model_nios32_1_br, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
  { NIOS32BF_INSN_PFXIO, model_nios32_1_pfx, { { (int) UNIT_NIOS32_1_U_EXEC, 1, 1 } } },
};

#endif /* WITH_PROFILE_MODEL_P */

static void
nios32_1_model_init (SIM_CPU *cpu)
{
  CPU_MODEL_DATA (cpu) = (void *) zalloc (sizeof (MODEL_NIOS32_1_DATA));
}

#if WITH_PROFILE_MODEL_P
#define TIMING_DATA(td) td
#else
#define TIMING_DATA(td) 0
#endif

static const MODEL nios32_models[] =
{
  { "nios32-1", & nios32_mach, MODEL_NIOS32_1, TIMING_DATA (& nios32_1_timing[0]), nios32_1_model_init },
  { 0 }
};

/* The properties of this cpu's implementation.  */

static const MACH_IMP_PROPERTIES nios32bf_imp_properties =
{
  sizeof (SIM_CPU),
#if WITH_SCACHE
  sizeof (SCACHE)
#else
  0
#endif
};


static void
nios32bf_prepare_run (SIM_CPU *cpu)
{
  if (CPU_IDESC (cpu) == NULL)
    nios32bf_init_idesc_table (cpu);
}

static const CGEN_INSN *
nios32bf_get_idata (SIM_CPU *cpu, int inum)
{
  return CPU_IDESC (cpu) [inum].idata;
}

static void
nios32_init_cpu (SIM_CPU *cpu)
{
  CPU_REG_FETCH (cpu) = nios32bf_fetch_register;
  CPU_REG_STORE (cpu) = nios32bf_store_register;
  CPU_PC_FETCH (cpu) = nios32bf_h_pc_get;
  CPU_PC_STORE (cpu) = nios32bf_h_pc_set;
  CPU_GET_IDATA (cpu) = nios32bf_get_idata;
  CPU_MAX_INSNS (cpu) = NIOS32BF_INSN_MAX;
  CPU_INSN_NAME (cpu) = cgen_insn_name;
  CPU_FULL_ENGINE_FN (cpu) = nios32bf_engine_run_full;
#if WITH_FAST
  CPU_FAST_ENGINE_FN (cpu) = nios32bf_engine_run_fast;
#else
  CPU_FAST_ENGINE_FN (cpu) = nios32bf_engine_run_full;
#endif
}

const MACH nios32_mach =
{
  "nios32", "nios32", MACH_NIOS32,
  32, 32, & nios32_models[0], & nios32bf_imp_properties,
  nios32_init_cpu,
  nios32bf_prepare_run
};

