/* nios simulator support code
   Copyright (C) 1998, 1999 Free Software Foundation, Inc.
   Contributed by Cygnus Solutions.

This file is part of the GNU simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#define WANT_CPU


#include "sim-main.h"
#include "cgen-mem.h"
#include "cgen-ops.h"
#include "bfd.h"

SEM_PC
sim_engine_invalid_insn (SIM_CPU *cpu, IADDR cia, SEM_PC pc)
{
  CGEN_CPU_DESC cpu_desc = CPU_CPU_DESC(cpu);

  if (cpu_desc->machs & (1 << bfd_mach_nios32))
    nios32bf_invalid_insn (cpu, pc);
  else
    nios16bf_invalid_insn (cpu, pc);
  return pc;
}

