/* Simulator instruction semantics for nios16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifdef DEFINE_LABELS

  /* The labels have the case they have because the enum of insn types
     is all uppercase and in the non-stdc case the insn symbol is built
     into the enum name.  */

  static struct {
    int index;
    void *label;
  } labels[] = {
    { NIOS16BF_INSN_X_INVALID, && case_sem_INSN_X_INVALID },
    { NIOS16BF_INSN_X_AFTER, && case_sem_INSN_X_AFTER },
    { NIOS16BF_INSN_X_BEFORE, && case_sem_INSN_X_BEFORE },
    { NIOS16BF_INSN_X_CTI_CHAIN, && case_sem_INSN_X_CTI_CHAIN },
    { NIOS16BF_INSN_X_CHAIN, && case_sem_INSN_X_CHAIN },
    { NIOS16BF_INSN_X_BEGIN, && case_sem_INSN_X_BEGIN },
    { NIOS16BF_INSN_EXT8S16, && case_sem_INSN_EXT8S16 },
    { NIOS16BF_INSN_ST8S16, && case_sem_INSN_ST8S16 },
    { NIOS16BF_INSN_STS8S16, && case_sem_INSN_STS8S16 },
    { NIOS16BF_INSN_ST8D16, && case_sem_INSN_ST8D16 },
    { NIOS16BF_INSN_WRCTL16, && case_sem_INSN_WRCTL16 },
    { NIOS16BF_INSN_ADDC16, && case_sem_INSN_ADDC16 },
    { NIOS16BF_INSN_SUBC16, && case_sem_INSN_SUBC16 },
    { NIOS16BF_INSN_ADD16, && case_sem_INSN_ADD16 },
    { NIOS16BF_INSN_SUB16, && case_sem_INSN_SUB16 },
    { NIOS16BF_INSN_ADDI16, && case_sem_INSN_ADDI16 },
    { NIOS16BF_INSN_SUBI16, && case_sem_INSN_SUBI16 },
    { NIOS16BF_INSN_OR16, && case_sem_INSN_OR16 },
    { NIOS16BF_INSN_XOR16, && case_sem_INSN_XOR16 },
    { NIOS16BF_INSN_AND16, && case_sem_INSN_AND16 },
    { NIOS16BF_INSN_ANDN16, && case_sem_INSN_ANDN16 },
    { NIOS16BF_INSN_LSL16, && case_sem_INSN_LSL16 },
    { NIOS16BF_INSN_LSR16, && case_sem_INSN_LSR16 },
    { NIOS16BF_INSN_ASR16, && case_sem_INSN_ASR16 },
    { NIOS16BF_INSN_LSLI16, && case_sem_INSN_LSLI16 },
    { NIOS16BF_INSN_LSRI16, && case_sem_INSN_LSRI16 },
    { NIOS16BF_INSN_ASRI16, && case_sem_INSN_ASRI16 },
    { NIOS16BF_INSN_NOT16, && case_sem_INSN_NOT16 },
    { NIOS16BF_INSN_NEG16, && case_sem_INSN_NEG16 },
    { NIOS16BF_INSN_ABS16, && case_sem_INSN_ABS16 },
    { NIOS16BF_INSN_MOV16, && case_sem_INSN_MOV16 },
    { NIOS16BF_INSN_MOVI16, && case_sem_INSN_MOVI16 },
    { NIOS16BF_INSN_BGEN16, && case_sem_INSN_BGEN16 },
    { NIOS16BF_INSN_CMP16, && case_sem_INSN_CMP16 },
    { NIOS16BF_INSN_CMPI16, && case_sem_INSN_CMPI16 },
//    { NIOS16BF_INSN_LDC16, && case_sem_INSN_LDC16 },
    { NIOS16BF_INSN_EXT8D16, && case_sem_INSN_EXT8D16 },
    { NIOS16BF_INSN_SEXT816, && case_sem_INSN_SEXT816 },
    { NIOS16BF_INSN_FILL816, && case_sem_INSN_FILL816 },
    { NIOS16BF_INSN_LDS16, && case_sem_INSN_LDS16 },
    { NIOS16BF_INSN_STS16, && case_sem_INSN_STS16 },
    { NIOS16BF_INSN_LDP16, && case_sem_INSN_LDP16 },
    { NIOS16BF_INSN_STP16, && case_sem_INSN_STP16 },
    { NIOS16BF_INSN_LD16, && case_sem_INSN_LD16 },
    { NIOS16BF_INSN_ST16, && case_sem_INSN_ST16 },
    { NIOS16BF_INSN_TRAP16, && case_sem_INSN_TRAP16 },
    { NIOS16BF_INSN_TRET16, && case_sem_INSN_TRET16 },
    { NIOS16BF_INSN_SAVE16, && case_sem_INSN_SAVE16 },
    { NIOS16BF_INSN_RESTORE16, && case_sem_INSN_RESTORE16 },
    { NIOS16BF_INSN_BSR16, && case_sem_INSN_BSR16 },
    { NIOS16BF_INSN_JMP16, && case_sem_INSN_JMP16 },
    { NIOS16BF_INSN_CALL16, && case_sem_INSN_CALL16 },
    { NIOS16BF_INSN_JMPC16, && case_sem_INSN_JMPC16 },
    { NIOS16BF_INSN_CALLC16, && case_sem_INSN_CALLC16 },
    { NIOS16BF_INSN_SKP016, && case_sem_INSN_SKP016 },
    { NIOS16BF_INSN_SKP116, && case_sem_INSN_SKP116 },
    { NIOS16BF_INSN_SKPRZ16, && case_sem_INSN_SKPRZ16 },
    { NIOS16BF_INSN_SKPRNZ16, && case_sem_INSN_SKPRNZ16 },
    { NIOS16BF_INSN_SKPS16, && case_sem_INSN_SKPS16 },
    { NIOS16BF_INSN_RRC16, && case_sem_INSN_RRC16 },
    { NIOS16BF_INSN_RLC16, && case_sem_INSN_RLC16 },
    { NIOS16BF_INSN_RDCTL16, && case_sem_INSN_RDCTL16 },
    { NIOS16BF_INSN_PFX, && case_sem_INSN_PFX },
    { NIOS16BF_INSN_BR, && case_sem_INSN_BR },
    { NIOS16BF_INSN_PFXIO, && case_sem_INSN_PFX },
    { 0, 0 }
  };
  int i;

  for (i = 0; labels[i].label != 0; ++i)
    {
#if FAST_P
      CPU_IDESC (current_cpu) [labels[i].index].sem_fast_lab = labels[i].label;
#else
      CPU_IDESC (current_cpu) [labels[i].index].sem_full_lab = labels[i].label;
#endif
    }

#undef DEFINE_LABELS
#endif /* DEFINE_LABELS */

#ifdef DEFINE_SWITCH

/* If hyper-fast [well not unnecessarily slow] execution is selected, turn
   off frills like tracing and profiling.  */
/* FIXME: A better way would be to have TRACE_RESULT check for something
   that can cause it to be optimized out.  Another way would be to emit
   special handlers into the instruction "stream".  */

#if FAST_P
#undef TRACE_RESULT
#define TRACE_RESULT(cpu, abuf, name, type, val)
#endif

#undef GET_ATTR
#define GET_ATTR(cpu, num, attr) CGEN_ATTR_VALUE (NULL, abuf->idesc->attrs, CGEN_INSN_##attr)

{

#if WITH_SCACHE_PBB

/* Branch to next handler without going around main loop.  */
#define NEXT(vpc) goto * SEM_ARGBUF (vpc) -> semantic.sem_case
SWITCH (sem, SEM_ARGBUF (vpc) -> semantic.sem_case)

#else /* ! WITH_SCACHE_PBB */

#define NEXT(vpc) BREAK (sem)
#ifdef __GNUC__
#if FAST_P
  SWITCH (sem, SEM_ARGBUF (sc) -> idesc->sem_fast_lab)
#else
  SWITCH (sem, SEM_ARGBUF (sc) -> idesc->sem_full_lab)
#endif
#else
  SWITCH (sem, SEM_ARGBUF (sc) -> idesc->num)
#endif

#endif /* ! WITH_SCACHE_PBB */

    {

  CASE (sem, INSN_X_INVALID) : /* --invalid-- */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.fmt_empty.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
    /* Update the recorded pc in the cpu state struct.
       Only necessary for WITH_SCACHE case, but to avoid the
       conditional compilation ....  */
    SET_H_PC (pc);
    /* Virtual insns have zero size.  Overwrite vpc with address of next insn
       using the default-insn-bitsize spec.  When executing insns in parallel
       we may want to queue the fault and continue execution.  */
    vpc = SEM_NEXT_VPC (sem_arg, pc, 2);
    vpc = sim_engine_invalid_insn (current_cpu, pc, vpc);
  }

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_X_AFTER) : /* --after-- */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.fmt_empty.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS16BF
    nios16bf_pbb_after (current_cpu, sem_arg);
#endif
  }

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_X_BEFORE) : /* --before-- */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.fmt_empty.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS16BF
    nios16bf_pbb_before (current_cpu, sem_arg);
#endif
  }

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_X_CTI_CHAIN) : /* --cti-chain-- */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.fmt_empty.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS16BF
#ifdef DEFINE_SWITCH
    vpc = nios16bf_pbb_cti_chain (current_cpu, sem_arg,
			       pbb_br_type, pbb_br_npc);
    BREAK (sem);
#else
    /* FIXME: Allow provision of explicit ifmt spec in insn spec.  */
    vpc = nios16bf_pbb_cti_chain (current_cpu, sem_arg,
			       CPU_PBB_BR_TYPE (current_cpu),
			       CPU_PBB_BR_NPC (current_cpu));
#endif
#endif
  }

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_X_CHAIN) : /* --chain-- */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.fmt_empty.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS16BF
    vpc = nios16bf_pbb_chain (current_cpu, sem_arg);
#ifdef DEFINE_SWITCH
    BREAK (sem);
#endif
#endif
  }

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_X_BEGIN) : /* --begin-- */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.fmt_empty.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS16BF
#ifdef DEFINE_SWITCH
    /* In the switch case FAST_P is a constant, allowing several optimizations
       in any called inline functions.  */
    vpc = nios16bf_pbb_begin (current_cpu, FAST_P);
#else
    vpc = nios16bf_pbb_begin (current_cpu, STATE_RUN_FAST_P (CPU_STATE (current_cpu)));
#endif
#endif
  }

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_EXT8S16) : /* ext8s $m16_Ra,$i1 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ext8s16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDHI (SRLHI (GET_H_M16_GR (FLD (f_Ra)), SLLSI (FLD (f_i1), 3)), 255);
  {
    HI opval = tmp_tmp;
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ST8S16) : /* st8s [$m16_Ra],$m16_R0,$i1 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ext8s16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  QI tmp_tmp;
  HI tmp_K1;
  HI tmp_ea_word;
if (EQBI (CPU (h_pbit), 1)) {
  tmp_K1 = ORHI (FLD (f_i1), SRAHI (CPU (h_k), 4));
} else {
  tmp_K1 = FLD (f_i1);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCHIQI (SRLHI (GET_H_M16_GR0 (), SLLSI (FLD (f_i1), 3)));
  tmp_ea_word = SLLHI (SRLHI (GET_H_M16_GR (FLD (f_Ra)), 1), 1);
  {
    QI opval = tmp_tmp;
    SETMEMQI (current_cpu, pc, ZEXTHISI (ADDHI (tmp_ea_word, tmp_K1)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_STS8S16) : /* sts8s [$m16_sp,$i10],$m16_R0 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_sts8s16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  HI tmp_tmp2;
  HI tmp_ea_word;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDSI (ZEXTSISI (FLD (f_i10)), 1);
  tmp_tmp2 = SRLHI (GET_H_M16_GR0 (), SLLSI (tmp_tmp, 3));
  tmp_ea_word = ANDHI (65534, ADDHI (GET_H_M16_SP (), FLD (f_i10)));
  {
    UQI opval = TRUNCHIQI (tmp_tmp2);
    SETMEMUQI (current_cpu, pc, ZEXTHISI (ADDHI (tmp_ea_word, tmp_tmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ST8D16) : /* st8d [$m16_Ra],$m16_R0 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  QI tmp_tmp;
  HI tmp_Ktmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_Ktmp = SRAHI (CPU (h_k), 4);
} else {
  tmp_Ktmp = 0;
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCHIQI (SRLHI (GET_H_M16_GR0 (), ZEXTHISI (SLLHI (ANDHI (GET_H_M16_GR (FLD (f_Ra)), 1), 3))));
  {
    QI opval = tmp_tmp;
    SETMEMQI (current_cpu, pc, ZEXTHISI (ADDHI (GET_H_M16_GR (FLD (f_Ra)), tmp_Ktmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_WRCTL16) : /* wrctl $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (EQBI (CPU (h_pbit), 0)) {
  {
    HI opval = 0;
    CPU (h_k) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "K", 'x', opval);
  }
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
if (EQHI (CPU (h_k), 0)) {
  {
    BI opval = 1;
    CPU (h_wbit) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "wbit", 'x', opval);
  }
}
  tmp_tmp = ZEXTHISI (SRLHI (CPU (h_k), 5));
  {
    HI opval = GET_H_M16_GR (FLD (f_Ra));
    SET_H_M16_CTL (tmp_tmp, opval);
    TRACE_RESULT (current_cpu, abuf, "m16-ctl-tmp", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ADDC16) : /* addc $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  BI tmp_old_cbit;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_old_cbit = CPU (h_cbit);
  {
    BI opval = ADDOFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), CPU (h_cbit));
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = ADDCFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), CPU (h_cbit));
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = ADDCHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), tmp_old_cbit);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SUBC16) : /* subc $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  BI tmp_old_cbit;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_old_cbit = CPU (h_cbit);
  {
    BI opval = SUBOFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), CPU (h_cbit));
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), CPU (h_cbit));
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = SUBCHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), tmp_old_cbit);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ADD16) : /* add $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = ADDOFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = ADDCFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = ADDHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SUB16) : /* sub $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = SUBHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ADDI16) : /* addi $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHIHI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = ADDOFHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = ADDCFHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = ADDHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SUBI16) : /* subi $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHIHI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = SUBHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_OR16) : /* or $m16_Ra,$Rbi5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_or16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = ZEXTHIHI (ORHI (CPU (h_k), FLD (f_Rbi5)));
} else {
  tmp_tmp = GET_H_M16_GR (FLD (f_Rbi5));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = ORHI (GET_H_M16_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_XOR16) : /* xor $m16_Ra,$Rbi5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_or16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = ZEXTHIHI (ORHI (CPU (h_k), FLD (f_Rbi5)));
} else {
  tmp_tmp = GET_H_M16_GR (FLD (f_Rbi5));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = XORHI (GET_H_M16_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_AND16) : /* and $m16_Ra,$Rbi5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_or16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = ZEXTHIHI (ORHI (CPU (h_k), FLD (f_Rbi5)));
} else {
  tmp_tmp = GET_H_M16_GR (FLD (f_Rbi5));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = ANDHI (GET_H_M16_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ANDN16) : /* andn $m16_Ra,$Rbi5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_or16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = INVHI (ZEXTHIHI (ORHI (CPU (h_k), FLD (f_Rbi5))));
} else {
  tmp_tmp = INVHI (GET_H_M16_GR (FLD (f_Rbi5)));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = ANDHI (GET_H_M16_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
{
  {
    BI opval = EQHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (GET_H_M16_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LSL16) : /* lsl $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  {
    HI opval = SLLHI (GET_H_M16_GR (FLD (f_Ra)), ANDSI (ZEXTHISI (GET_H_M16_GR (FLD (f_Rb))), tmp_mask));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LSR16) : /* lsr $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  {
    HI opval = SRLHI (GET_H_M16_GR (FLD (f_Ra)), ANDSI (ZEXTHISI (GET_H_M16_GR (FLD (f_Rb))), tmp_mask));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ASR16) : /* asr $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  {
    HI opval = SRAHI (GET_H_M16_GR (FLD (f_Ra)), ANDSI (ZEXTHISI (GET_H_M16_GR (FLD (f_Rb))), tmp_mask));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LSLI16) : /* lsli $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  {
    HI opval = SLLHI (GET_H_M16_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (FLD (f_i5)), tmp_mask));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LSRI16) : /* lsri $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  {
    HI opval = SRLHI (GET_H_M16_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (FLD (f_i5)), tmp_mask));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ASRI16) : /* asri $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  {
    HI opval = SRAHI (GET_H_M16_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (FLD (f_i5)), tmp_mask));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_NOT16) : /* not $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = INVHI (GET_H_M16_GR (FLD (f_Ra)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_NEG16) : /* neg $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = NEGHI (GET_H_M16_GR (FLD (f_Ra)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ABS16) : /* abs $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = ABSHI (GET_H_M16_GR (FLD (f_Ra)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_MOV16) : /* mov $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = GET_H_M16_GR (FLD (f_Rb));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_MOVI16) : /* movi $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHIHI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = tmp_K5;
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_BGEN16) : /* bgen $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  tmp_tmp = ZEXTSISI (ANDSI (FLD (f_i5), tmp_mask));
  {
    HI opval = SLLHI (1, tmp_tmp);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_CMP16) : /* cmp $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)), 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  tmp_tmp = SUBHI (GET_H_M16_GR (FLD (f_Ra)), GET_H_M16_GR (FLD (f_Rb)));
{
  {
    BI opval = EQHI (tmp_tmp, 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (tmp_tmp, 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_CMPI16) : /* cmpi $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHIHI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  tmp_tmp = SUBHI (GET_H_M16_GR (FLD (f_Ra)), tmp_K5);
{
  {
    BI opval = EQHI (tmp_tmp, 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTHI (tmp_tmp, 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LDC16) : /* ldc $m16_Ra,[$m16_i6] */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = GETMEMHI (current_cpu, pc, FLD (i_m16_i6));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_EXT8D16) : /* ext8d $m16_Ra,$m16_Rb */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (SRLSI (16, 3), 1);
  tmp_tmp = ANDSI (ZEXTHISI (GET_H_M16_GR (FLD (f_Rb))), tmp_mask);
  {
    HI opval = SRLHI (GET_H_M16_GR (FLD (f_Ra)), SLLSI (tmp_tmp, 3));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
  {
    HI opval = ANDHI (GET_H_M16_GR (FLD (f_Ra)), 255);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SEXT816) : /* sext8 $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  QI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCHIQI (GET_H_M16_GR (FLD (f_Ra)));
  {
    HI opval = EXTQIHI (tmp_tmp);
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_FILL816) : /* fill8 $m16_R0,$m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDHI (GET_H_M16_GR (FLD (f_Ra)), 255);
  tmp_tmp2 = SLLHI (tmp_tmp, 8);
  tmp_tmp = ORHI (tmp_tmp, tmp_tmp2);
((void) 0); /*nop*/
  {
    HI opval = tmp_tmp;
    SET_H_M16_GR0 (opval);
    TRACE_RESULT (current_cpu, abuf, "m16_R0", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LDS16) : /* lds $m16_Ra,[$m16_sp,$i8] */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  SI tmp_word_bits;
  HI tmp_sp_word;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (16, 4);
  tmp_tmp = SLLHI (FLD (f_i8), tmp_word_bits);
  tmp_sp_word = SLLHI (SRLHI (GET_H_M16_SP (), tmp_word_bits), tmp_word_bits);
  {
    HI opval = GETMEMHI (current_cpu, pc, ZEXTHISI (ADDHI (tmp_sp_word, tmp_tmp)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_STS16) : /* sts [$m16_sp,$i8],$m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  SI tmp_word_bits;
  HI tmp_sp_word;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (16, 4);
  tmp_tmp = SLLHI (FLD (f_i8), tmp_word_bits);
  tmp_sp_word = SLLHI (SRLHI (GET_H_M16_SP (), tmp_word_bits), tmp_word_bits);
  {
    HI opval = GET_H_M16_GR (FLD (f_Ra));
    SETMEMHI (current_cpu, pc, ZEXTHISI (ADDHI (tmp_sp_word, tmp_tmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LDP16) : /* ldp $m16_Ra,[$m16_Rp,$i5] */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_K5;
  SI tmp_word_bits;
  HI tmp_bp_word;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = EXTHIHI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (16, 4);
  tmp_tmp = SLLHI (tmp_K5, tmp_word_bits);
  tmp_bp_word = SLLHI (SRLHI (GET_H_M16_BP (FLD (f_Rp)), tmp_word_bits), tmp_word_bits);
  {
    HI opval = GETMEMHI (current_cpu, pc, ZEXTHISI (ADDHI (tmp_bp_word, tmp_tmp)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_STP16) : /* stp [$m16_Rp,$i5],$m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_K5;
  SI tmp_word_bits;
  HI tmp_bp_word;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = EXTHIHI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (16, 4);
  tmp_tmp = SLLHI (tmp_K5, tmp_word_bits);
  tmp_bp_word = SLLHI (SRLHI (GET_H_M16_BP (FLD (f_Rp)), tmp_word_bits), tmp_word_bits);
  {
    HI opval = GET_H_M16_GR (FLD (f_Ra));
    SETMEMHI (current_cpu, pc, ZEXTHISI (ADDHI (tmp_bp_word, tmp_tmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_LD16) : /* ld $m16_Ra,[$m16_Rb] */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_Ktmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_Ktmp = SRAHI (EXTHIHI (CPU (h_k)), 5);
} else {
  tmp_Ktmp = 0;
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = SLLHI (tmp_Ktmp, SRLSI (16, 4));
  {
    HI opval = GETMEMHI (current_cpu, pc, ZEXTHISI (ADDHI (GET_H_M16_GR (FLD (f_Rb)), tmp_tmp)));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_ST16) : /* st [$m16_Rb],$m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_addc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_Ktmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_Ktmp = SRAHI (EXTHIHI (CPU (h_k)), 5);
} else {
  tmp_Ktmp = 0;
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = SLLHI (tmp_Ktmp, SRLSI (16, 4));
  {
    HI opval = GET_H_M16_GR (FLD (f_Ra));
    SETMEMHI (current_cpu, pc, ZEXTHISI (ADDHI (GET_H_M16_GR (FLD (f_Rb)), tmp_tmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_TRAP16) : /* trap $i6v */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_trap16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = nios16bf_sw_trap (current_cpu, pc, FLD (f_i6v));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_TRET16) : /* tret $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = nios16bf_do_tret (current_cpu, pc, GET_H_M16_GR (FLD (f_Ra)));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SAVE16) : /* save $m16_sp,$save_i8v */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_save16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
nios16bf_do_save (current_cpu, pc, FLD (f_i8v));
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_RESTORE16) : /* restore */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.fmt_empty.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
nios16bf_do_restore (current_cpu, pc);
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_BSR16) : /* bsr $rel11 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_bsr16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = TRUNCSIHI (SRLSI (ADDSI (pc, 4), 1));
    SET_H_M16_GR (((UINT) 15), opval);
    TRACE_RESULT (current_cpu, abuf, "m16-gr-15", 'x', opval);
  }
  {
    USI opval = FLD (i_rel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_JMP16) : /* jmp $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = SLLSI (ZEXTHISI (GET_H_M16_GR (FLD (f_Ra))), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_CALL16) : /* call $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = TRUNCSIHI (SRLSI (ADDSI (pc, 4), 1));
    SET_H_M16_GR (((UINT) 15), opval);
    TRACE_RESULT (current_cpu, abuf, "m16-gr-15", 'x', opval);
  }
  {
    USI opval = SLLSI (ZEXTHISI (GET_H_M16_GR (FLD (f_Ra))), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_JMPC16) : /* jmpc [$m16_i8v] */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_jmpc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp2 = GETMEMHI (current_cpu, pc, FLD (i_m16_i8v));
  {
    USI opval = SLLSI (ZEXTHISI (tmp_tmp2), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_CALLC16) : /* callc [$m16_i8v] */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_jmpc16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = TRUNCSIHI (SRLSI (ADDSI (pc, 4), 1));
    SET_H_M16_GR (((UINT) 15), opval);
    TRACE_RESULT (current_cpu, abuf, "m16-gr-15", 'x', opval);
  }
  tmp_tmp2 = GETMEMHI (current_cpu, pc, FLD (i_m16_i8v));
  {
    USI opval = SLLSI (ZEXTHISI (tmp_tmp2), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SKP016) : /* skp0 $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  tmp_tmp = SLLSI (1, ANDSI (FLD (f_i5), tmp_mask));
  tmp_tmp2 = ANDSI (tmp_tmp, ZEXTHISI (GET_H_M16_GR (FLD (f_Ra))));
if (EQSI (tmp_tmp2, 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SKP116) : /* skp1 $m16_Ra,$i5 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_ldp16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (16, 1);
  tmp_tmp = SLLSI (1, ANDSI (FLD (f_i5), tmp_mask));
  tmp_tmp2 = ANDSI (tmp_tmp, ZEXTHISI (GET_H_M16_GR (FLD (f_Ra))));
if (NESI (tmp_tmp2, 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SKPRZ16) : /* skprz $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
if (EQHI (GET_H_M16_GR (FLD (f_Ra)), 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SKPRNZ16) : /* skprnz $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
if (NEHI (GET_H_M16_GR (FLD (f_Ra)), 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_SKPS16) : /* skps $i4w */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_skps16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  USI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = nios16bf_check_cc_mask (current_cpu, FLD (f_i4w));
    CPU (h_sbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_RRC16) : /* rrc $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = SLLHI (ZEXTBIHI (CPU (h_cbit)), SUBSI (16, 1));
  {
    BI opval = TRUNCHIBI (ANDHI (GET_H_M16_GR (FLD (f_Ra)), 1));
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = ORHI (tmp_tmp, SRLHI (GET_H_M16_GR (FLD (f_Ra)), 1));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_RLC16) : /* rlc $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  HI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ZEXTBIHI (CPU (h_cbit));
  {
    BI opval = TRUNCHIBI (SRLHI (GET_H_M16_GR (FLD (f_Ra)), SUBSI (16, 1)));
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    HI opval = ORHI (tmp_tmp, SLLHI (GET_H_M16_GR (FLD (f_Ra)), 1));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_RDCTL16) : /* rdctl $m16_Ra */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_lds16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (EQBI (CPU (h_pbit), 0)) {
  {
    HI opval = 0;
    CPU (h_k) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "K", 'x', opval);
  }
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ZEXTHISI (SRLHI (CPU (h_k), 5));
  {
    HI opval = ZEXTHIHI (GET_H_M16_CTL (tmp_tmp));
    SET_H_M16_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m16_Ra", 'x', opval);
  }
}

  abuf->written = written;
#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_PFX) : /* pfx $i11 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_pfx.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 1;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = SLLSI (FLD (f_i11), 5);
    CPU (h_k) = opval;
    TRACE_RESULT (current_cpu, abuf, "K", 'x', opval);
  }
}

#undef FLD
}
  NEXT (vpc);

  CASE (sem, INSN_BR) : /* br $rel11 */
{
  SEM_ARG sem_arg = SEM_SEM_ARG (vpc, sc);
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
#define FLD(f) abuf->fields.sfmt_bsr16.f
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = FLD (i_rel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
#undef FLD
}
  NEXT (vpc);


    }
  ENDSWITCH (sem) /* End of semantic switch.  */

  /* At this point `vpc' contains the next insn to execute.  */
}

#undef DEFINE_SWITCH
#endif /* DEFINE_SWITCH */
