/* Simulator instruction semantics for nios32bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU nios32bf
#define WANT_CPU_NIOS32BF

#include "sim-main.h"
#include "cgen-mem.h"
#include "cgen-ops.h"

#undef GET_ATTR
#define GET_ATTR(cpu, num, attr) CGEN_ATTR_VALUE (NULL, abuf->idesc->attrs, CGEN_INSN_##attr)

/* This is used so that we can compile two copies of the semantic code,
   one with full feature support and one without that runs fast(er).
   FAST_P, when desired, is defined on the command line, -DFAST_P=1.  */
#if FAST_P
#define SEM_FN_NAME(cpu,fn) XCONCAT3 (cpu,_semf_,fn)
#undef TRACE_RESULT
#define TRACE_RESULT(cpu, abuf, name, type, val)
#else
#define SEM_FN_NAME(cpu,fn) XCONCAT3 (cpu,_sem_,fn)
#endif

/* x-invalid: --invalid-- */

static SEM_PC
SEM_FN_NAME (nios32bf,x_invalid) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
    /* Update the recorded pc in the cpu state struct.
       Only necessary for WITH_SCACHE case, but to avoid the
       conditional compilation ....  */
    SET_H_PC (pc);
    /* Virtual insns have zero size.  Overwrite vpc with address of next insn
       using the default-insn-bitsize spec.  When executing insns in parallel
       we may want to queue the fault and continue execution.  */
    vpc = SEM_NEXT_VPC (sem_arg, pc, 2);
    vpc = sim_engine_invalid_insn (current_cpu, pc, vpc);
  }

  return vpc;
#undef FLD
}

/* x-after: --after-- */

static SEM_PC
SEM_FN_NAME (nios32bf,x_after) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS32BF
    nios32bf_pbb_after (current_cpu, sem_arg);
#endif
  }

  return vpc;
#undef FLD
}

/* x-before: --before-- */

static SEM_PC
SEM_FN_NAME (nios32bf,x_before) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS32BF
    nios32bf_pbb_before (current_cpu, sem_arg);
#endif
  }

  return vpc;
#undef FLD
}

/* x-cti-chain: --cti-chain-- */

static SEM_PC
SEM_FN_NAME (nios32bf,x_cti_chain) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS32BF
#ifdef DEFINE_SWITCH
    vpc = nios32bf_pbb_cti_chain (current_cpu, sem_arg,
			       pbb_br_type, pbb_br_npc);
    BREAK (sem);
#else
    /* FIXME: Allow provision of explicit ifmt spec in insn spec.  */
    vpc = nios32bf_pbb_cti_chain (current_cpu, sem_arg,
			       CPU_PBB_BR_TYPE (current_cpu),
			       CPU_PBB_BR_NPC (current_cpu));
#endif
#endif
  }

  return vpc;
#undef FLD
}

/* x-chain: --chain-- */

static SEM_PC
SEM_FN_NAME (nios32bf,x_chain) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS32BF
    vpc = nios32bf_pbb_chain (current_cpu, sem_arg);
#ifdef DEFINE_SWITCH
    BREAK (sem);
#endif
#endif
  }

  return vpc;
#undef FLD
}

/* x-begin: --begin-- */

static SEM_PC
SEM_FN_NAME (nios32bf,x_begin) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 0);

  {
#if WITH_SCACHE_PBB_NIOS32BF
#ifdef DEFINE_SWITCH
    /* In the switch case FAST_P is a constant, allowing several optimizations
       in any called inline functions.  */
    vpc = nios32bf_pbb_begin (current_cpu, FAST_P);
#else
    vpc = nios32bf_pbb_begin (current_cpu, STATE_RUN_FAST_P (CPU_STATE (current_cpu)));
#endif
#endif
  }

  return vpc;
#undef FLD
}

/* sts8s32: sts8s [$m32_sp,$i10],$m32_R0 */

static SEM_PC
SEM_FN_NAME (nios32bf,sts8s32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_sts8s32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  SI tmp_ea_word;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDSI (ZEXTSISI (FLD (f_i10)), 3);
  tmp_tmp2 = SRLSI (GET_H_M32_GR0 (), SLLSI (tmp_tmp, 3));
  tmp_ea_word = ANDSI (0xfffffffc, ADDSI (GET_H_M32_SP (), FLD (f_i10)));
  {
    UQI opval = TRUNCSIQI (tmp_tmp2);
    SETMEMUQI (current_cpu, pc, ADDSI (tmp_ea_word, tmp_tmp), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* sts16s: sts16s [$m32_sp,$i9],$m32_R0 */

static SEM_PC
SEM_FN_NAME (nios32bf,sts16s) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_sts16s.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  SI tmp_ea_word;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDSI (ZEXTSISI (FLD (f_i9)), 1);
  tmp_tmp2 = SRLSI (GET_H_M32_GR0 (), SLLSI (tmp_tmp, 4));
  tmp_ea_word = ANDSI (0xfffffffc, ADDSI (GET_H_M32_SP (), SLLSI (FLD (f_i9), 1)));
  {
    UHI opval = TRUNCSIHI (tmp_tmp2);
    SETMEMUHI (current_cpu, pc, ADDSI (tmp_ea_word, SLLSI (tmp_tmp, 1)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* movhi: movhi $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,movhi) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_K5;
  SI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHISI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDSI (GET_H_M32_GR (FLD (f_Ra)), 65535);
  {
    SI opval = ORSI (tmp_tmp, SLLSI (tmp_K5, 16));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ext16d: ext16d $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,ext16d) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDSI (GET_H_M32_GR (FLD (f_Rb)), 2);
  {
    SI opval = SRLSI (GET_H_M32_GR (FLD (f_Ra)), SLLSI (tmp_tmp, 3));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
  {
    SI opval = ANDSI (GET_H_M32_GR (FLD (f_Ra)), 65535);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* sext16: sext16 $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,sext16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCSIHI (GET_H_M32_GR (FLD (f_Ra)));
  {
    SI opval = EXTHISI (tmp_tmp);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* st16d: st16d [$m32_Ra],$m32_R0 */

static SEM_PC
SEM_FN_NAME (nios32bf,st16d) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  SI tmp_Ktmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_Ktmp = SRASI (EXTHISI (CPU (h_k)), 3);
} else {
  tmp_Ktmp = 0;
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCSIHI (SRLSI (GET_H_M32_GR0 (), SLLSI (ANDSI (GET_H_M32_GR (FLD (f_Ra)), 2), 3)));
  {
    HI opval = tmp_tmp;
    SETMEMHI (current_cpu, pc, ANDSI (ADDSI (GET_H_M32_GR (FLD (f_Ra)), tmp_Ktmp), 0xfffffffe), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* fill16: fill16 $m32_R0,$m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,fill16) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDSI (GET_H_M32_GR (FLD (f_Ra)), 65535);
  tmp_tmp2 = SLLSI (tmp_tmp, 16);
  tmp_tmp = ORSI (tmp_tmp, tmp_tmp2);
  {
    SI opval = tmp_tmp;
    SET_H_M32_GR0 (opval);
    TRACE_RESULT (current_cpu, abuf, "m32_R0", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ext8s32: ext8s $m32_Ra,$i2 */

static SEM_PC
SEM_FN_NAME (nios32bf,ext8s32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext8s32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  UQI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCSIQI (SRLSI (GET_H_M32_GR (FLD (f_Ra)), SLLSI (FLD (f_i2), 3)));
  {
    SI opval = tmp_tmp;
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* st8s32: st8s [$m32_Ra],$m32_R0,$i2 */

static SEM_PC
SEM_FN_NAME (nios32bf,st8s32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext8s32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  UQI tmp_tmp;
  SI tmp_K2;
  SI tmp_m32_Ra_word;
if (EQBI (CPU (h_pbit), 1)) {
  tmp_K2 = EXTHISI (ORHI (FLD (f_i2), SRAHI (CPU (h_k), 3)));
} else {
  tmp_K2 = FLD (f_i2);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCSIQI (SRLSI (GET_H_M32_GR0 (), SLLSI (FLD (f_i2), 3)));
  tmp_m32_Ra_word = SLLSI (SRLSI (GET_H_M32_GR (FLD (f_Ra)), 2), 2);
  {
    UQI opval = tmp_tmp;
    SETMEMUQI (current_cpu, pc, ADDSI (tmp_m32_Ra_word, tmp_K2), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ext16s: ext16s $m32_Ra,$i1 */

static SEM_PC
SEM_FN_NAME (nios32bf,ext16s) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16s.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = SRLSI (GET_H_M32_GR (FLD (f_Ra)), SLLSI (FLD (f_i1), 4));
  {
    SI opval = ANDSI (tmp_tmp, 65535);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* st16s: st16s [$m32_Ra],$m32_R0,$i1 */

static SEM_PC
SEM_FN_NAME (nios32bf,st16s) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16s.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  HI tmp_tmp;
  SI tmp_m32_Ra_word;
  SI tmp_K1;
if (EQBI (CPU (h_pbit), 1)) {
  tmp_K1 = ORSI (FLD (f_i1), EXTHISI (SRAHI (CPU (h_k), 4)));
} else {
  tmp_K1 = FLD (f_i1);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCSIHI (SRLSI (GET_H_M32_GR0 (), SLLSI (FLD (f_i1), 4)));
  tmp_m32_Ra_word = SLLSI (SRLSI (GET_H_M32_GR (FLD (f_Ra)), 2), 2);
  {
    HI opval = tmp_tmp;
    SETMEMHI (current_cpu, pc, ADDSI (tmp_m32_Ra_word, SLLSI (tmp_K1, 1)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* st8d32: st8d [$m32_Ra],$m32_R0 */

static SEM_PC
SEM_FN_NAME (nios32bf,st8d32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  QI tmp_tmp;
  SI tmp_Ktmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_Ktmp = SRASI (EXTHISI (CPU (h_k)), 3);
} else {
  tmp_Ktmp = 0;
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCSIQI (SRLSI (GET_H_M32_GR0 (), SLLSI (ANDSI (GET_H_M32_GR (FLD (f_Ra)), 3), 3)));
  {
    QI opval = tmp_tmp;
    SETMEMQI (current_cpu, pc, ADDSI (GET_H_M32_GR (FLD (f_Ra)), tmp_Ktmp), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* wrctl32: wrctl $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,wrctl32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (EQBI (CPU (h_pbit), 0)) {
  {
    HI opval = 0;
    CPU (h_k) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "K", 'x', opval);
  }
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
if (EQHI (CPU (h_k), 0)) {
  {
    BI opval = 1;
    CPU (h_wbit) = opval;
    written |= (1 << 6);
    TRACE_RESULT (current_cpu, abuf, "wbit", 'x', opval);
  }
}
  tmp_tmp = ZEXTHISI (SRLHI (CPU (h_k), 5));
  {
    HI opval = TRUNCSIHI (GET_H_M32_GR (FLD (f_Ra)));
    SET_H_M32_CTL (tmp_tmp, opval);
    TRACE_RESULT (current_cpu, abuf, "m32-ctl-tmp", 'x', opval);
  }
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* add32: add $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,add32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = ADDOFSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)), 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = ADDCFSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)), 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    SI opval = ADDSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* sub32: sub $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,sub32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)), 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)), 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    SI opval = SUBSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* addi32: addi $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,addi32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHISI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = ADDOFSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = ADDCFSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    SI opval = ADDSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* subi32: subi $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,subi32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHISI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    SI opval = SUBSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* or32: or $m32_Ra,$Rbi5 */

static SEM_PC
SEM_FN_NAME (nios32bf,or32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = ZEXTHISI (ORHI (CPU (h_k), FLD (f_Rbi5)));
} else {
  tmp_tmp = GET_H_M32_GR (FLD (f_Rbi5));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = ORSI (GET_H_M32_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* xor32: xor $m32_Ra,$Rbi5 */

static SEM_PC
SEM_FN_NAME (nios32bf,xor32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = ZEXTHISI (ORHI (CPU (h_k), FLD (f_Rbi5)));
} else {
  tmp_tmp = GET_H_M32_GR (FLD (f_Rbi5));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = XORSI (GET_H_M32_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* and32: and $m32_Ra,$Rbi5 */

static SEM_PC
SEM_FN_NAME (nios32bf,and32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = ZEXTHISI (ORHI (CPU (h_k), FLD (f_Rbi5)));
} else {
  tmp_tmp = GET_H_M32_GR (FLD (f_Rbi5));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = ANDSI (GET_H_M32_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* andn32: andn $m32_Ra,$Rbi5 */

static SEM_PC
SEM_FN_NAME (nios32bf,andn32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_or32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_tmp = INVSI (ZEXTHISI (ORHI (CPU (h_k), FLD (f_Rbi5))));
} else {
  tmp_tmp = INVSI (GET_H_M32_GR (FLD (f_Rbi5)));
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = ANDSI (GET_H_M32_GR (FLD (f_Ra)), tmp_tmp);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
{
  {
    BI opval = EQSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (GET_H_M32_GR (FLD (f_Ra)), 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* lsl32: lsl $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,lsl32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  {
    SI opval = SLLSI (GET_H_M32_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (GET_H_M32_GR (FLD (f_Rb))), tmp_mask));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* lsr32: lsr $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,lsr32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  {
    SI opval = SRLSI (GET_H_M32_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (GET_H_M32_GR (FLD (f_Rb))), tmp_mask));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* asr32: asr $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,asr32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  {
    SI opval = SRASI (GET_H_M32_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (GET_H_M32_GR (FLD (f_Rb))), tmp_mask));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* lsli32: lsli $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,lsli32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  {
    SI opval = SLLSI (GET_H_M32_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (FLD (f_i5)), tmp_mask));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* lsri32: lsri $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,lsri32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  {
    SI opval = SRLSI (GET_H_M32_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (FLD (f_i5)), tmp_mask));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* asri32: asri $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,asri32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  {
    SI opval = SRASI (GET_H_M32_GR (FLD (f_Ra)), ANDSI (ZEXTSISI (FLD (f_i5)), tmp_mask));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* not32: not $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,not32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = INVSI (GET_H_M32_GR (FLD (f_Ra)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* neg32: neg $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,neg32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = NEGSI (GET_H_M32_GR (FLD (f_Ra)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* abs32: abs $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,abs32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = ABSSI (GET_H_M32_GR (FLD (f_Ra)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* mov32: mov $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,mov32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = GET_H_M32_GR (FLD (f_Rb));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* movi32: movi $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,movi32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHISI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = tmp_K5;
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* bgen32: bgen $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,bgen32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  tmp_tmp = ZEXTSISI (ANDSI (FLD (f_i5), tmp_mask));
  {
    SI opval = SLLSI (1, tmp_tmp);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* cmp32: cmp $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,cmp32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)), 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)), 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  tmp_tmp = SUBSI (GET_H_M32_GR (FLD (f_Ra)), GET_H_M32_GR (FLD (f_Rb)));
{
  {
    BI opval = EQSI (tmp_tmp, 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (tmp_tmp, 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* cmpi32: cmpi $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,cmpi32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_K5;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = ZEXTHISI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = SUBOFSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_vbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "vbit", 'x', opval);
  }
  {
    BI opval = SUBCFSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5, 0);
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  tmp_tmp = SUBSI (GET_H_M32_GR (FLD (f_Ra)), tmp_K5);
{
  {
    BI opval = EQSI (tmp_tmp, 0);
    CPU (h_zbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "zbit", 'x', opval);
  }
  {
    BI opval = LTSI (tmp_tmp, 0);
    CPU (h_nbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "nbit", 'x', opval);
  }
}
}

  return vpc;
#undef FLD
}

/* ldc32: ldc $m32_Ra,[$m32_i6] */

static SEM_PC
SEM_FN_NAME (nios32bf,ldc32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldc32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = GETMEMSI (current_cpu, pc, FLD (i_m32_i6));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ext8d32: ext8d $m32_Ra,$m32_Rb */

static SEM_PC
SEM_FN_NAME (nios32bf,ext8d32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (SRLSI (32, 3), 1);
  tmp_tmp = ANDSI (ZEXTSISI (GET_H_M32_GR (FLD (f_Rb))), tmp_mask);
  {
    SI opval = SRLSI (GET_H_M32_GR (FLD (f_Ra)), SLLSI (tmp_tmp, 3));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
  {
    SI opval = ANDSI (GET_H_M32_GR (FLD (f_Ra)), 255);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* sext832: sext8 $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,sext832) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  QI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = TRUNCSIQI (GET_H_M32_GR (FLD (f_Ra)));
  {
    SI opval = EXTQISI (tmp_tmp);
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* fill832: fill8 $m32_R0,$m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,fill832) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ANDSI (GET_H_M32_GR (FLD (f_Ra)), 255);
  tmp_tmp2 = SLLSI (tmp_tmp, 8);
  tmp_tmp = ORSI (tmp_tmp, tmp_tmp2);
{
  tmp_tmp2 = SLLSI (tmp_tmp, 16);
  tmp_tmp = ORSI (tmp_tmp, tmp_tmp2);
}
  {
    SI opval = tmp_tmp;
    SET_H_M32_GR0 (opval);
    TRACE_RESULT (current_cpu, abuf, "m32_R0", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* lds32: lds $m32_Ra,[$m32_sp,$i8] */

static SEM_PC
SEM_FN_NAME (nios32bf,lds32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_word_bits;
  SI tmp_sp_word;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (32, 4);
  tmp_tmp = SLLSI (FLD (f_i8), tmp_word_bits);
  tmp_sp_word = SLLSI (SRLSI (GET_H_M32_SP (), tmp_word_bits), tmp_word_bits);
  {
    SI opval = GETMEMSI (current_cpu, pc, ZEXTSISI (ADDSI (tmp_sp_word, tmp_tmp)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* sts32: sts [$m32_sp,$i8],$m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,sts32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_word_bits;
  SI tmp_sp_word;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (32, 4);
  tmp_tmp = SLLSI (FLD (f_i8), tmp_word_bits);
  tmp_sp_word = SLLSI (SRLSI (GET_H_M32_SP (), tmp_word_bits), tmp_word_bits);
  {
    SI opval = GET_H_M32_GR (FLD (f_Ra));
    SETMEMSI (current_cpu, pc, ZEXTSISI (ADDSI (tmp_sp_word, tmp_tmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ldp32: ldp $m32_Ra,[$m32_Rp,$i5] */

static SEM_PC
SEM_FN_NAME (nios32bf,ldp32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_K5;
  SI tmp_word_bits;
  SI tmp_bp_word;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = EXTHISI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (32, 4);
  tmp_tmp = SLLSI (tmp_K5, tmp_word_bits);
  tmp_bp_word = SLLSI (SRLSI (GET_H_M32_BP (FLD (f_Rp)), tmp_word_bits), tmp_word_bits);
  {
    SI opval = GETMEMSI (current_cpu, pc, ZEXTSISI (ADDSI (tmp_bp_word, tmp_tmp)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* stp32: stp [$m32_Rp,$i5],$m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,stp32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_K5;
  SI tmp_word_bits;
  SI tmp_bp_word;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_K5 = EXTHISI (ORHI (CPU (h_k), FLD (f_i5)));
} else {
  tmp_K5 = FLD (f_i5);
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_word_bits = SRLSI (32, 4);
  tmp_tmp = SLLSI (tmp_K5, tmp_word_bits);
  tmp_bp_word = SLLSI (SRLSI (GET_H_M32_BP (FLD (f_Rp)), tmp_word_bits), tmp_word_bits);
  {
    SI opval = GET_H_M32_GR (FLD (f_Ra));
    SETMEMSI (current_cpu, pc, ZEXTSISI (ADDSI (tmp_bp_word, tmp_tmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* ld32: ld $m32_Ra,[$m32_Rb] */

static SEM_PC
SEM_FN_NAME (nios32bf,ld32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_Ktmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_Ktmp = SRASI (EXTHISI (CPU (h_k)), 5);
} else {
  tmp_Ktmp = 0;
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = SLLSI (tmp_Ktmp, SRLSI (32, 4));
  {
    SI opval = GETMEMSI (current_cpu, pc, ZEXTSISI (ADDSI (GET_H_M32_GR (FLD (f_Rb)), tmp_tmp)));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* st32: st [$m32_Rb],$m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,st32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ext16d.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_Ktmp;
if (NEBI (CPU (h_pbit), 0)) {
  tmp_Ktmp = SRASI (EXTHISI (CPU (h_k)), 5);
} else {
  tmp_Ktmp = 0;
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = SLLSI (tmp_Ktmp, SRLSI (32, 4));
  {
    SI opval = GET_H_M32_GR (FLD (f_Ra));
    SETMEMSI (current_cpu, pc, ZEXTSISI (ADDSI (GET_H_M32_GR (FLD (f_Rb)), tmp_tmp)), opval);
    TRACE_RESULT (current_cpu, abuf, "memory", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* trap32: trap $i6v */

static SEM_PC
SEM_FN_NAME (nios32bf,trap32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_trap32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = nios32bf_sw_trap (current_cpu, pc, FLD (f_i6v));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* tret32: tret $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,tret32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = nios32bf_do_tret (current_cpu, pc, GET_H_M32_GR (FLD (f_Ra)));
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* save32: save $m32_sp,$save_i8v */

static SEM_PC
SEM_FN_NAME (nios32bf,save32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_save32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
nios32bf_do_save (current_cpu, pc, FLD (f_i8v));
}

  return vpc;
#undef FLD
}

/* restore32: restore */

static SEM_PC
SEM_FN_NAME (nios32bf,restore32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.fmt_empty.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
nios32bf_do_restore (current_cpu, pc);
}

  return vpc;
#undef FLD
}

/* bsr32: bsr $rel11 */

static SEM_PC
SEM_FN_NAME (nios32bf,bsr32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsr32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = TRUNCSISI (SRLSI (ADDSI (pc, 4), 1));
    SET_H_M32_GR (((UINT) 15), opval);
    TRACE_RESULT (current_cpu, abuf, "m32-gr-15", 'x', opval);
  }
  {
    USI opval = FLD (i_rel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jmp32: jmp $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,jmp32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = SLLSI (ZEXTSISI (GET_H_M32_GR (FLD (f_Ra))), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* call32: call $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,call32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = TRUNCSISI (SRLSI (ADDSI (pc, 4), 1));
    SET_H_M32_GR (((UINT) 15), opval);
    TRACE_RESULT (current_cpu, abuf, "m32-gr-15", 'x', opval);
  }
  {
    USI opval = SLLSI (ZEXTSISI (GET_H_M32_GR (FLD (f_Ra))), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* jmpc32: jmpc [$m32_i8v] */

static SEM_PC
SEM_FN_NAME (nios32bf,jmpc32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_jmpc32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp2 = GETMEMSI (current_cpu, pc, FLD (i_m32_i8v));
  {
    USI opval = SLLSI (ZEXTSISI (tmp_tmp2), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* callc32: callc [$m32_i8v] */

static SEM_PC
SEM_FN_NAME (nios32bf,callc32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_jmpc32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    SI opval = TRUNCSISI (SRLSI (ADDSI (pc, 4), 1));
    SET_H_M32_GR (((UINT) 15), opval);
    TRACE_RESULT (current_cpu, abuf, "m32-gr-15", 'x', opval);
  }
  tmp_tmp2 = GETMEMSI (current_cpu, pc, FLD (i_m32_i8v));
  {
    USI opval = SLLSI (ZEXTSISI (tmp_tmp2), 1);
    SEM_BRANCH_VIA_ADDR (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* skp032: skp0 $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,skp032) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  tmp_tmp = SLLSI (1, ANDSI (FLD (f_i5), tmp_mask));
  tmp_tmp2 = ANDSI (tmp_tmp, ZEXTSISI (GET_H_M32_GR (FLD (f_Ra))));
if (EQSI (tmp_tmp2, 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* skp132: skp1 $m32_Ra,$i5 */

static SEM_PC
SEM_FN_NAME (nios32bf,skp132) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_ldp32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  SI tmp_mask;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_mask = SUBSI (32, 1);
  tmp_tmp = SLLSI (1, ANDSI (FLD (f_i5), tmp_mask));
  tmp_tmp2 = ANDSI (tmp_tmp, ZEXTSISI (GET_H_M32_GR (FLD (f_Ra))));
if (NESI (tmp_tmp2, 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* skprz32: skprz $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,skprz32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
if (EQSI (GET_H_M32_GR (FLD (f_Ra)), 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* skprnz32: skprnz $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,skprnz32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
if (NESI (GET_H_M32_GR (FLD (f_Ra)), 0)) {
  {
    BI opval = 1;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
} else {
  {
    BI opval = 0;
    CPU (h_sbit) = opval;
    written |= (1 << 2);
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}
}

  abuf->written = written;
  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* skps32: skps $i4w */

static SEM_PC
SEM_FN_NAME (nios32bf,skps32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_skps32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  USI tmp_tmp;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    BI opval = nios32bf_check_cc_mask (current_cpu, FLD (f_i4w));
    CPU (h_sbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "sbit", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* rrc32: rrc $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,rrc32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = SLLSI (ZEXTBISI (CPU (h_cbit)), SUBSI (32, 1));
  {
    BI opval = TRUNCSIBI (ANDSI (GET_H_M32_GR (FLD (f_Ra)), 1));
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    SI opval = ORSI (tmp_tmp, SRLSI (GET_H_M32_GR (FLD (f_Ra)), 1));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* rlc32: rlc $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,rlc32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
  SI tmp_tmp2;
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ZEXTBISI (CPU (h_cbit));
  {
    BI opval = TRUNCSIBI (SRLSI (GET_H_M32_GR (FLD (f_Ra)), SUBSI (32, 1)));
    CPU (h_cbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "cbit", 'x', opval);
  }
  {
    SI opval = ORSI (tmp_tmp, SLLSI (GET_H_M32_GR (FLD (f_Ra)), 1));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* rdctl32: rdctl $m32_Ra */

static SEM_PC
SEM_FN_NAME (nios32bf,rdctl32) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_lds32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  SI tmp_tmp;
if (EQBI (CPU (h_pbit), 0)) {
  {
    HI opval = 0;
    CPU (h_k) = opval;
    written |= (1 << 3);
    TRACE_RESULT (current_cpu, abuf, "K", 'x', opval);
  }
}
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  tmp_tmp = ZEXTHISI (SRLHI (CPU (h_k), 5));
  {
    SI opval = ZEXTHISI (GET_H_M32_CTL (tmp_tmp));
    SET_H_M32_GR (FLD (f_Ra), opval);
    TRACE_RESULT (current_cpu, abuf, "m32_Ra", 'x', opval);
  }
}

  abuf->written = written;
  return vpc;
#undef FLD
}

/* pfx: pfx $i11 */

static SEM_PC
SEM_FN_NAME (nios32bf,pfx) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_pfx.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 1;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    HI opval = SLLSI (FLD (f_i11), 5);
    CPU (h_k) = opval;
    TRACE_RESULT (current_cpu, abuf, "K", 'x', opval);
  }
}

  return vpc;
#undef FLD
}

/* br: br $rel11 */

static SEM_PC
SEM_FN_NAME (nios32bf,br) (SIM_CPU *current_cpu, SEM_ARG sem_arg)
{
#define FLD(f) abuf->fields.sfmt_bsr32.f
  ARGBUF *abuf = SEM_ARGBUF (sem_arg);
  int UNUSED written = 0;
  IADDR UNUSED pc = abuf->addr;
  SEM_BRANCH_INIT
  SEM_PC vpc = SEM_NEXT_VPC (sem_arg, pc, 2);

{
  {
    BI opval = 0;
    CPU (h_pbit) = opval;
    TRACE_RESULT (current_cpu, abuf, "pbit", 'x', opval);
  }
  {
    USI opval = FLD (i_rel11);
    SEM_BRANCH_VIA_CACHE (current_cpu, sem_arg, opval, vpc);
    TRACE_RESULT (current_cpu, abuf, "pc", 'x', opval);
  }
}

  SEM_BRANCH_FINI (vpc);
  return vpc;
#undef FLD
}

/* Table of all semantic fns.  */

static const struct sem_fn_desc sem_fns[] = {
  { NIOS32BF_INSN_X_INVALID, SEM_FN_NAME (nios32bf,x_invalid) },
  { NIOS32BF_INSN_X_AFTER, SEM_FN_NAME (nios32bf,x_after) },
  { NIOS32BF_INSN_X_BEFORE, SEM_FN_NAME (nios32bf,x_before) },
  { NIOS32BF_INSN_X_CTI_CHAIN, SEM_FN_NAME (nios32bf,x_cti_chain) },
  { NIOS32BF_INSN_X_CHAIN, SEM_FN_NAME (nios32bf,x_chain) },
  { NIOS32BF_INSN_X_BEGIN, SEM_FN_NAME (nios32bf,x_begin) },
  { NIOS32BF_INSN_STS8S32, SEM_FN_NAME (nios32bf,sts8s32) },
  { NIOS32BF_INSN_STS16S, SEM_FN_NAME (nios32bf,sts16s) },
  { NIOS32BF_INSN_MOVHI, SEM_FN_NAME (nios32bf,movhi) },
  { NIOS32BF_INSN_EXT16D, SEM_FN_NAME (nios32bf,ext16d) },
  { NIOS32BF_INSN_SEXT16, SEM_FN_NAME (nios32bf,sext16) },
  { NIOS32BF_INSN_ST16D, SEM_FN_NAME (nios32bf,st16d) },
  { NIOS32BF_INSN_FILL16, SEM_FN_NAME (nios32bf,fill16) },
  { NIOS32BF_INSN_EXT8S32, SEM_FN_NAME (nios32bf,ext8s32) },
  { NIOS32BF_INSN_ST8S32, SEM_FN_NAME (nios32bf,st8s32) },
  { NIOS32BF_INSN_EXT16S, SEM_FN_NAME (nios32bf,ext16s) },
  { NIOS32BF_INSN_ST16S, SEM_FN_NAME (nios32bf,st16s) },
  { NIOS32BF_INSN_ST8D32, SEM_FN_NAME (nios32bf,st8d32) },
  { NIOS32BF_INSN_WRCTL32, SEM_FN_NAME (nios32bf,wrctl32) },
  { NIOS32BF_INSN_ADD32, SEM_FN_NAME (nios32bf,add32) },
  { NIOS32BF_INSN_SUB32, SEM_FN_NAME (nios32bf,sub32) },
  { NIOS32BF_INSN_ADDI32, SEM_FN_NAME (nios32bf,addi32) },
  { NIOS32BF_INSN_SUBI32, SEM_FN_NAME (nios32bf,subi32) },
  { NIOS32BF_INSN_OR32, SEM_FN_NAME (nios32bf,or32) },
  { NIOS32BF_INSN_XOR32, SEM_FN_NAME (nios32bf,xor32) },
  { NIOS32BF_INSN_AND32, SEM_FN_NAME (nios32bf,and32) },
  { NIOS32BF_INSN_ANDN32, SEM_FN_NAME (nios32bf,andn32) },
  { NIOS32BF_INSN_LSL32, SEM_FN_NAME (nios32bf,lsl32) },
  { NIOS32BF_INSN_LSR32, SEM_FN_NAME (nios32bf,lsr32) },
  { NIOS32BF_INSN_ASR32, SEM_FN_NAME (nios32bf,asr32) },
  { NIOS32BF_INSN_LSLI32, SEM_FN_NAME (nios32bf,lsli32) },
  { NIOS32BF_INSN_LSRI32, SEM_FN_NAME (nios32bf,lsri32) },
  { NIOS32BF_INSN_ASRI32, SEM_FN_NAME (nios32bf,asri32) },
  { NIOS32BF_INSN_NOT32, SEM_FN_NAME (nios32bf,not32) },
  { NIOS32BF_INSN_NEG32, SEM_FN_NAME (nios32bf,neg32) },
  { NIOS32BF_INSN_ABS32, SEM_FN_NAME (nios32bf,abs32) },
  { NIOS32BF_INSN_MOV32, SEM_FN_NAME (nios32bf,mov32) },
  { NIOS32BF_INSN_MOVI32, SEM_FN_NAME (nios32bf,movi32) },
  { NIOS32BF_INSN_BGEN32, SEM_FN_NAME (nios32bf,bgen32) },
  { NIOS32BF_INSN_CMP32, SEM_FN_NAME (nios32bf,cmp32) },
  { NIOS32BF_INSN_CMPI32, SEM_FN_NAME (nios32bf,cmpi32) },
//  { NIOS32BF_INSN_LDC32, SEM_FN_NAME (nios32bf,ldc32) },
  { NIOS32BF_INSN_EXT8D32, SEM_FN_NAME (nios32bf,ext8d32) },
  { NIOS32BF_INSN_SEXT832, SEM_FN_NAME (nios32bf,sext832) },
  { NIOS32BF_INSN_FILL832, SEM_FN_NAME (nios32bf,fill832) },
  { NIOS32BF_INSN_LDS32, SEM_FN_NAME (nios32bf,lds32) },
  { NIOS32BF_INSN_STS32, SEM_FN_NAME (nios32bf,sts32) },
  { NIOS32BF_INSN_LDP32, SEM_FN_NAME (nios32bf,ldp32) },
  { NIOS32BF_INSN_STP32, SEM_FN_NAME (nios32bf,stp32) },
  { NIOS32BF_INSN_LD32, SEM_FN_NAME (nios32bf,ld32) },
  { NIOS32BF_INSN_ST32, SEM_FN_NAME (nios32bf,st32) },
  { NIOS32BF_INSN_TRAP32, SEM_FN_NAME (nios32bf,trap32) },
  { NIOS32BF_INSN_TRET32, SEM_FN_NAME (nios32bf,tret32) },
  { NIOS32BF_INSN_SAVE32, SEM_FN_NAME (nios32bf,save32) },
  { NIOS32BF_INSN_RESTORE32, SEM_FN_NAME (nios32bf,restore32) },
  { NIOS32BF_INSN_BSR32, SEM_FN_NAME (nios32bf,bsr32) },
  { NIOS32BF_INSN_JMP32, SEM_FN_NAME (nios32bf,jmp32) },
  { NIOS32BF_INSN_CALL32, SEM_FN_NAME (nios32bf,call32) },
  { NIOS32BF_INSN_JMPC32, SEM_FN_NAME (nios32bf,jmpc32) },
  { NIOS32BF_INSN_CALLC32, SEM_FN_NAME (nios32bf,callc32) },
  { NIOS32BF_INSN_SKP032, SEM_FN_NAME (nios32bf,skp032) },
  { NIOS32BF_INSN_SKP132, SEM_FN_NAME (nios32bf,skp132) },
  { NIOS32BF_INSN_SKPRZ32, SEM_FN_NAME (nios32bf,skprz32) },
  { NIOS32BF_INSN_SKPRNZ32, SEM_FN_NAME (nios32bf,skprnz32) },
  { NIOS32BF_INSN_SKPS32, SEM_FN_NAME (nios32bf,skps32) },
  { NIOS32BF_INSN_RRC32, SEM_FN_NAME (nios32bf,rrc32) },
  { NIOS32BF_INSN_RLC32, SEM_FN_NAME (nios32bf,rlc32) },
  { NIOS32BF_INSN_RDCTL32, SEM_FN_NAME (nios32bf,rdctl32) },
  { NIOS32BF_INSN_PFX, SEM_FN_NAME (nios32bf,pfx) },
  { NIOS32BF_INSN_BR, SEM_FN_NAME (nios32bf,br) },
  { NIOS32BF_INSN_PFXIO, SEM_FN_NAME (nios32bf,pfx) },
  { 0, 0 }
};

/* Add the semantic fns to IDESC_TABLE.  */

void
SEM_FN_NAME (nios32bf,init_idesc_table) (SIM_CPU *current_cpu)
{
  IDESC *idesc_table = CPU_IDESC (current_cpu);
  const struct sem_fn_desc *sf;
  int mach_num = MACH_NUM (CPU_MACH (current_cpu));

  for (sf = &sem_fns[0]; sf->fn != 0; ++sf)
    {
      const CGEN_INSN *insn = idesc_table[sf->index].idata;
      int valid_p = (CGEN_INSN_VIRTUAL_P (insn)
		     || CGEN_INSN_MACH_HAS_P (insn, mach_num));
#if FAST_P
      if (valid_p)
	idesc_table[sf->index].sem_fast = sf->fn;
      else
	idesc_table[sf->index].sem_fast = SEM_FN_NAME (nios32bf,x_invalid);
#else
      if (valid_p)
	idesc_table[sf->index].sem_full = sf->fn;
      else
	idesc_table[sf->index].sem_full = SEM_FN_NAME (nios32bf,x_invalid);
#endif
    }
}

