/* Misc. support for CPU family nios32bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU nios32bf
#define WANT_CPU_NIOS32BF

#include "sim-main.h"
#include "cgen-ops.h"

/* Get the value of h-pc.  */

USI
nios32bf_h_pc_get (SIM_CPU *current_cpu)
{
  return CPU (h_pc);
}

/* Set a value for h-pc.  */

void
nios32bf_h_pc_set (SIM_CPU *current_cpu, USI newval)
{
  CPU (h_pc) = newval;
}

/* Get the value of h-cwp.  */

UQI
nios32bf_h_cwp_get (SIM_CPU *current_cpu)
{
  return CPU (h_cwp);
}

/* Set a value for h-cwp.  */

void
nios32bf_h_cwp_set (SIM_CPU *current_cpu, UQI newval)
{
  SET_H_CWP (newval);
}

/* Get the value of h-old-cwp.  */

UQI
nios32bf_h_old_cwp_get (SIM_CPU *current_cpu)
{
  return CPU (h_old_cwp);
}

/* Set a value for h-old-cwp.  */

void
nios32bf_h_old_cwp_set (SIM_CPU *current_cpu, UQI newval)
{
  CPU (h_old_cwp) = newval;
}

/* Get the value of h-ipri.  */

UQI
nios32bf_h_ipri_get (SIM_CPU *current_cpu)
{
  return CPU (h_ipri);
}

/* Set a value for h-ipri.  */

void
nios32bf_h_ipri_set (SIM_CPU *current_cpu, UQI newval)
{
  CPU (h_ipri) = newval;
}

/* Get the value of h-zero.  */

BI
nios32bf_h_zero_get (SIM_CPU *current_cpu, UINT regno)
{
  return CPU (h_zero[regno]);
}

/* Set a value for h-zero.  */

void
nios32bf_h_zero_set (SIM_CPU *current_cpu, UINT regno, BI newval)
{
  CPU (h_zero[regno]) = newval;
}

/* Get the value of h-tebit.  */

BI
nios32bf_h_tebit_get (SIM_CPU *current_cpu)
{
  return CPU (h_tebit);
}

/* Set a value for h-tebit.  */

void
nios32bf_h_tebit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_tebit) = newval;
}

/* Get the value of h-nbit.  */

BI
nios32bf_h_nbit_get (SIM_CPU *current_cpu)
{
  return CPU (h_nbit);
}

/* Set a value for h-nbit.  */

void
nios32bf_h_nbit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_nbit) = newval;
}

/* Get the value of h-zbit.  */

BI
nios32bf_h_zbit_get (SIM_CPU *current_cpu)
{
  return CPU (h_zbit);
}

/* Set a value for h-zbit.  */

void
nios32bf_h_zbit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_zbit) = newval;
}

/* Get the value of h-vbit.  */

BI
nios32bf_h_vbit_get (SIM_CPU *current_cpu)
{
  return CPU (h_vbit);
}

/* Set a value for h-vbit.  */

void
nios32bf_h_vbit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_vbit) = newval;
}

/* Get the value of h-cbit.  */

BI
nios32bf_h_cbit_get (SIM_CPU *current_cpu)
{
  return CPU (h_cbit);
}

/* Set a value for h-cbit.  */

void
nios32bf_h_cbit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_cbit) = newval;
}

/* Get the value of h-pbit.  */

BI
nios32bf_h_pbit_get (SIM_CPU *current_cpu)
{
  return CPU (h_pbit);
}

/* Set a value for h-pbit.  */

void
nios32bf_h_pbit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_pbit) = newval;
}

/* Get the value of h-sbit.  */

BI
nios32bf_h_sbit_get (SIM_CPU *current_cpu)
{
  return CPU (h_sbit);
}

/* Set a value for h-sbit.  */

void
nios32bf_h_sbit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_sbit) = newval;
}

/* Get the value of h-wbit.  */

BI
nios32bf_h_wbit_get (SIM_CPU *current_cpu)
{
  return CPU (h_wbit);
}

/* Set a value for h-wbit.  */

void
nios32bf_h_wbit_set (SIM_CPU *current_cpu, BI newval)
{
  CPU (h_wbit) = newval;
}

/* Get the value of h-status.  */

UHI
nios32bf_h_status_get (SIM_CPU *current_cpu)
{
  return GET_H_STATUS ();
}

/* Set a value for h-status.  */

void
nios32bf_h_status_set (SIM_CPU *current_cpu, UHI newval)
{
  SET_H_STATUS (newval);
}

/* Get the value of h-k.  */

HI
nios32bf_h_k_get (SIM_CPU *current_cpu)
{
  return CPU (h_k);
}

/* Set a value for h-k.  */

void
nios32bf_h_k_set (SIM_CPU *current_cpu, HI newval)
{
  CPU (h_k) = newval;
}

/* Get the value of h-m32-gr.  */

SI
nios32bf_h_m32_gr_get (SIM_CPU *current_cpu, UINT regno)
{
  return GET_H_M32_GR (regno);
}

/* Set a value for h-m32-gr.  */

void
nios32bf_h_m32_gr_set (SIM_CPU *current_cpu, UINT regno, SI newval)
{
  SET_H_M32_GR (regno, newval);
}

/* Get the value of h-m32-gr0.  */

SI
nios32bf_h_m32_gr0_get (SIM_CPU *current_cpu)
{
  return GET_H_M32_GR0 ();
}

/* Set a value for h-m32-gr0.  */

void
nios32bf_h_m32_gr0_set (SIM_CPU *current_cpu, SI newval)
{
  SET_H_M32_GR0 (newval);
}

/* Get the value of h-m32-bp.  */

SI
nios32bf_h_m32_bp_get (SIM_CPU *current_cpu, UINT regno)
{
  return GET_H_M32_BP (regno);
}

/* Set a value for h-m32-bp.  */

void
nios32bf_h_m32_bp_set (SIM_CPU *current_cpu, UINT regno, SI newval)
{
  SET_H_M32_BP (regno, newval);
}

/* Get the value of h-m32-rz.  */

SI
nios32bf_h_m32_rz_get (SIM_CPU *current_cpu, UINT regno)
{
  return GET_H_M32_RZ (regno);
}

/* Set a value for h-m32-rz.  */

void
nios32bf_h_m32_rz_set (SIM_CPU *current_cpu, UINT regno, SI newval)
{
  SET_H_M32_RZ (regno, newval);
}

/* Get the value of h-m32-sp.  */

SI
nios32bf_h_m32_sp_get (SIM_CPU *current_cpu)
{
  return GET_H_M32_SP ();
}

/* Set a value for h-m32-sp.  */

void
nios32bf_h_m32_sp_set (SIM_CPU *current_cpu, SI newval)
{
  SET_H_M32_SP (newval);
}

/* Get the value of h-m32-ctl.  */

UHI
nios32bf_h_m32_ctl_get (SIM_CPU *current_cpu, UINT regno)
{
  return GET_H_M32_CTL (regno);
}

/* Set a value for h-m32-ctl.  */

void
nios32bf_h_m32_ctl_set (SIM_CPU *current_cpu, UINT regno, UHI newval)
{
  SET_H_M32_CTL (regno, newval);
}

/* Record trace results for INSN.  */

void
nios32bf_record_trace_results (SIM_CPU *current_cpu, CGEN_INSN *insn,
			    int *indices, TRACE_RECORD *tr)
{
}
