/* Simulator instruction decoder for nios16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define WANT_CPU nios16bf
#define WANT_CPU_NIOS16BF

#include "sim-main.h"
#include "sim-assert.h"

/* The instruction descriptor array.
   This is computed at runtime.  Space for it is not malloc'd to save a
   teensy bit of cpu in the decoder.  Moving it to malloc space is trivial
   but won't be done until necessary (we don't currently support the runtime
   addition of instructions nor an SMP machine with different cpus).  */
static IDESC nios16bf_insn_data[NIOS16BF_INSN_MAX];

/* Commas between elements are contained in the macros.
   Some of these are conditionally compiled out.  */

static const struct insn_sem nios16bf_insn_sem[] =
{
  { VIRTUAL_INSN_X_INVALID, NIOS16BF_INSN_X_INVALID, NIOS16BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_AFTER, NIOS16BF_INSN_X_AFTER, NIOS16BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_BEFORE, NIOS16BF_INSN_X_BEFORE, NIOS16BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_CTI_CHAIN, NIOS16BF_INSN_X_CTI_CHAIN, NIOS16BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_CHAIN, NIOS16BF_INSN_X_CHAIN, NIOS16BF_SFMT_EMPTY },
  { VIRTUAL_INSN_X_BEGIN, NIOS16BF_INSN_X_BEGIN, NIOS16BF_SFMT_EMPTY },
  { NIOS_INSN_EXT8S16, NIOS16BF_INSN_EXT8S16, NIOS16BF_SFMT_EXT8S16 },
  { NIOS_INSN_ST8S16, NIOS16BF_INSN_ST8S16, NIOS16BF_SFMT_ST8S16 },
  { NIOS_INSN_STS8S16, NIOS16BF_INSN_STS8S16, NIOS16BF_SFMT_STS8S16 },
  { NIOS_INSN_ST8D16, NIOS16BF_INSN_ST8D16, NIOS16BF_SFMT_ST8D16 },
  { NIOS_INSN_WRCTL16, NIOS16BF_INSN_WRCTL16, NIOS16BF_SFMT_WRCTL16 },
  { NIOS_INSN_ADDC16, NIOS16BF_INSN_ADDC16, NIOS16BF_SFMT_ADDC16 },
  { NIOS_INSN_SUBC16, NIOS16BF_INSN_SUBC16, NIOS16BF_SFMT_ADDC16 },
  { NIOS_INSN_ADD16, NIOS16BF_INSN_ADD16, NIOS16BF_SFMT_ADD16 },
  { NIOS_INSN_SUB16, NIOS16BF_INSN_SUB16, NIOS16BF_SFMT_ADD16 },
  { NIOS_INSN_ADDI16, NIOS16BF_INSN_ADDI16, NIOS16BF_SFMT_ADDI16 },
  { NIOS_INSN_SUBI16, NIOS16BF_INSN_SUBI16, NIOS16BF_SFMT_ADDI16 },
  { NIOS_INSN_OR16, NIOS16BF_INSN_OR16, NIOS16BF_SFMT_OR16 },
  { NIOS_INSN_XOR16, NIOS16BF_INSN_XOR16, NIOS16BF_SFMT_OR16 },
  { NIOS_INSN_AND16, NIOS16BF_INSN_AND16, NIOS16BF_SFMT_OR16 },
  { NIOS_INSN_ANDN16, NIOS16BF_INSN_ANDN16, NIOS16BF_SFMT_OR16 },
  { NIOS_INSN_LSL16, NIOS16BF_INSN_LSL16, NIOS16BF_SFMT_LSL16 },
  { NIOS_INSN_LSR16, NIOS16BF_INSN_LSR16, NIOS16BF_SFMT_LSL16 },
  { NIOS_INSN_ASR16, NIOS16BF_INSN_ASR16, NIOS16BF_SFMT_LSL16 },
  { NIOS_INSN_LSLI16, NIOS16BF_INSN_LSLI16, NIOS16BF_SFMT_LSLI16 },
  { NIOS_INSN_LSRI16, NIOS16BF_INSN_LSRI16, NIOS16BF_SFMT_LSLI16 },
  { NIOS_INSN_ASRI16, NIOS16BF_INSN_ASRI16, NIOS16BF_SFMT_LSLI16 },
  { NIOS_INSN_NOT16, NIOS16BF_INSN_NOT16, NIOS16BF_SFMT_NOT16 },
  { NIOS_INSN_NEG16, NIOS16BF_INSN_NEG16, NIOS16BF_SFMT_NOT16 },
  { NIOS_INSN_ABS16, NIOS16BF_INSN_ABS16, NIOS16BF_SFMT_NOT16 },
  { NIOS_INSN_MOV16, NIOS16BF_INSN_MOV16, NIOS16BF_SFMT_MOV16 },
  { NIOS_INSN_MOVI16, NIOS16BF_INSN_MOVI16, NIOS16BF_SFMT_MOVI16 },
  { NIOS_INSN_BGEN16, NIOS16BF_INSN_BGEN16, NIOS16BF_SFMT_BGEN16 },
  { NIOS_INSN_CMP16, NIOS16BF_INSN_CMP16, NIOS16BF_SFMT_CMP16 },
  { NIOS_INSN_CMPI16, NIOS16BF_INSN_CMPI16, NIOS16BF_SFMT_CMPI16 },
  //{ NIOS_INSN_LDC16, NIOS16BF_INSN_LDC16, NIOS16BF_SFMT_LDC16 },
  { NIOS_INSN_EXT8D16, NIOS16BF_INSN_EXT8D16, NIOS16BF_SFMT_EXT8D16 },
  { NIOS_INSN_SEXT816, NIOS16BF_INSN_SEXT816, NIOS16BF_SFMT_SEXT816 },
  { NIOS_INSN_FILL816, NIOS16BF_INSN_FILL816, NIOS16BF_SFMT_FILL816 },
  { NIOS_INSN_LDS16, NIOS16BF_INSN_LDS16, NIOS16BF_SFMT_LDS16 },
  { NIOS_INSN_STS16, NIOS16BF_INSN_STS16, NIOS16BF_SFMT_STS16 },
  { NIOS_INSN_LDP16, NIOS16BF_INSN_LDP16, NIOS16BF_SFMT_LDP16 },
  { NIOS_INSN_STP16, NIOS16BF_INSN_STP16, NIOS16BF_SFMT_STP16 },
  { NIOS_INSN_LD16, NIOS16BF_INSN_LD16, NIOS16BF_SFMT_LD16 },
  { NIOS_INSN_ST16, NIOS16BF_INSN_ST16, NIOS16BF_SFMT_ST16 },
  { NIOS_INSN_TRAP16, NIOS16BF_INSN_TRAP16, NIOS16BF_SFMT_TRAP16 },
  { NIOS_INSN_TRET16, NIOS16BF_INSN_TRET16, NIOS16BF_SFMT_TRET16 },
  { NIOS_INSN_SAVE16, NIOS16BF_INSN_SAVE16, NIOS16BF_SFMT_SAVE16 },
  { NIOS_INSN_RESTORE16, NIOS16BF_INSN_RESTORE16, NIOS16BF_SFMT_RESTORE16 },
  { NIOS_INSN_BSR16, NIOS16BF_INSN_BSR16, NIOS16BF_SFMT_BSR16 },
  { NIOS_INSN_JMP16, NIOS16BF_INSN_JMP16, NIOS16BF_SFMT_JMP16 },
  { NIOS_INSN_CALL16, NIOS16BF_INSN_CALL16, NIOS16BF_SFMT_CALL16 },
  { NIOS_INSN_JMPC16, NIOS16BF_INSN_JMPC16, NIOS16BF_SFMT_JMPC16 },
  { NIOS_INSN_CALLC16, NIOS16BF_INSN_CALLC16, NIOS16BF_SFMT_CALLC16 },
  { NIOS_INSN_SKP016, NIOS16BF_INSN_SKP016, NIOS16BF_SFMT_SKP016 },
  { NIOS_INSN_SKP116, NIOS16BF_INSN_SKP116, NIOS16BF_SFMT_SKP016 },
  { NIOS_INSN_SKPRZ16, NIOS16BF_INSN_SKPRZ16, NIOS16BF_SFMT_SKPRZ16 },
  { NIOS_INSN_SKPRNZ16, NIOS16BF_INSN_SKPRNZ16, NIOS16BF_SFMT_SKPRZ16 },
  { NIOS_INSN_SKPS16, NIOS16BF_INSN_SKPS16, NIOS16BF_SFMT_SKPS16 },
  { NIOS_INSN_RRC16, NIOS16BF_INSN_RRC16, NIOS16BF_SFMT_RRC16 },
  { NIOS_INSN_RLC16, NIOS16BF_INSN_RLC16, NIOS16BF_SFMT_RRC16 },
  { NIOS_INSN_RDCTL16, NIOS16BF_INSN_RDCTL16, NIOS16BF_SFMT_RDCTL16 },
  { NIOS_INSN_PFX, NIOS16BF_INSN_PFX, NIOS16BF_SFMT_PFX },
  { NIOS_INSN_BR, NIOS16BF_INSN_BR, NIOS16BF_SFMT_BR },
};

static const struct insn_sem nios16bf_insn_sem_invalid = {
  VIRTUAL_INSN_X_INVALID, NIOS16BF_INSN_X_INVALID, NIOS16BF_SFMT_EMPTY
};

/* Initialize an IDESC from the compile-time computable parts.  */

static INLINE void
init_idesc (SIM_CPU *cpu, IDESC *id, const struct insn_sem *t)
{
  const CGEN_INSN *insn_table = CGEN_CPU_INSN_TABLE (CPU_CPU_DESC (cpu))->init_entries;

  id->num = t->index;
  id->sfmt = t->sfmt;
  if ((int) t->type <= 0)
    id->idata = & cgen_virtual_insn_table[- (int) t->type];
  else
    id->idata = & insn_table[t->type];
  id->attrs = CGEN_INSN_ATTRS (id->idata);
  /* Oh my god, a magic number.  */
  id->length = CGEN_INSN_BITSIZE (id->idata) / 8;

#if WITH_PROFILE_MODEL_P
  id->timing = & MODEL_TIMING (CPU_MODEL (cpu)) [t->index];
  {
    SIM_DESC sd = CPU_STATE (cpu);
    SIM_ASSERT (t->index == id->timing->num);
  }
#endif

  /* Semantic pointers are initialized elsewhere.  */
}

/* Initialize the instruction descriptor table.  */

void
nios16bf_init_idesc_table (SIM_CPU *cpu)
{
  IDESC *id,*tabend;
  const struct insn_sem *t,*tend;
  int tabsize = NIOS16BF_INSN_MAX;
  IDESC *table = nios16bf_insn_data;

  memset (table, 0, tabsize * sizeof (IDESC));

  /* First set all entries to the `invalid insn'.  */
  t = & nios16bf_insn_sem_invalid;
  for (id = table, tabend = table + tabsize; id < tabend; ++id)
    init_idesc (cpu, id, t);

  /* Now fill in the values for the chosen cpu.  */
  for (t = nios16bf_insn_sem, tend = t + sizeof (nios16bf_insn_sem) / sizeof (*t);
       t != tend; ++t)
    {
      init_idesc (cpu, & table[t->index], t);
    }

  /* Link the IDESC table into the cpu.  */
  CPU_IDESC (cpu) = table;
}

/* Given an instruction, return a pointer to its IDESC entry.  */

const IDESC *
nios16bf_decode (SIM_CPU *current_cpu, IADDR pc,
              CGEN_INSN_INT base_insn, CGEN_INSN_INT entire_insn,
              ARGBUF *abuf)
{
  /* Result of decoder.  */
  NIOS16BF_INSN_TYPE itype;

  {
    CGEN_INSN_INT insn = base_insn;

    {
      unsigned int val = (((insn >> 10) & (63 << 0)));
      switch (val)
      {
      case 0 : itype = NIOS16BF_INSN_ADD16; goto extract_sfmt_add16;
      case 1 : itype = NIOS16BF_INSN_ADDI16; goto extract_sfmt_addi16;
      case 2 : itype = NIOS16BF_INSN_SUB16; goto extract_sfmt_add16;
      case 3 : itype = NIOS16BF_INSN_SUBI16; goto extract_sfmt_addi16;
      case 4 : itype = NIOS16BF_INSN_CMP16; goto extract_sfmt_cmp16;
      case 5 : itype = NIOS16BF_INSN_CMPI16; goto extract_sfmt_cmpi16;
      case 6 : itype = NIOS16BF_INSN_LSL16; goto extract_sfmt_lsl16;
      case 7 : itype = NIOS16BF_INSN_LSLI16; goto extract_sfmt_lsli16;
      case 8 : itype = NIOS16BF_INSN_LSR16; goto extract_sfmt_lsl16;
      case 9 : itype = NIOS16BF_INSN_LSRI16; goto extract_sfmt_lsli16;
      case 10 : itype = NIOS16BF_INSN_ASR16; goto extract_sfmt_lsl16;
      case 11 : itype = NIOS16BF_INSN_ASRI16; goto extract_sfmt_lsli16;
      case 12 : itype = NIOS16BF_INSN_MOV16; goto extract_sfmt_mov16;
      case 13 : itype = NIOS16BF_INSN_MOVI16; goto extract_sfmt_movi16;
      case 14 : itype = NIOS16BF_INSN_AND16; goto extract_sfmt_or16;
      case 15 : itype = NIOS16BF_INSN_ANDN16; goto extract_sfmt_or16;
      case 16 : itype = NIOS16BF_INSN_OR16; goto extract_sfmt_or16;
      case 17 : itype = NIOS16BF_INSN_XOR16; goto extract_sfmt_or16;
      case 18 : itype = NIOS16BF_INSN_BGEN16; goto extract_sfmt_bgen16;
      case 19 : itype = NIOS16BF_INSN_EXT8D16; goto extract_sfmt_ext8d16;
      case 20 : itype = NIOS16BF_INSN_SKP016; goto extract_sfmt_skp016;
      case 21 : itype = NIOS16BF_INSN_SKP116; goto extract_sfmt_skp016;
      case 22 : itype = NIOS16BF_INSN_LD16; goto extract_sfmt_ld16;
      case 23 : itype = NIOS16BF_INSN_ST16; goto extract_sfmt_st16;
      case 24 : itype = NIOS16BF_INSN_STS8S16; goto extract_sfmt_sts8s16;
      case 26 : itype = NIOS16BF_INSN_ADDC16; goto extract_sfmt_addc16;
      case 27 : itype = NIOS16BF_INSN_SUBC16; goto extract_sfmt_addc16;
      case 29 :
        {
          unsigned int val = (((insn >> 7) & (7 << 0)));
          switch (val)
          {
          case 0 : itype = NIOS16BF_INSN_EXT8S16; goto extract_sfmt_ext8s16;
          case 4 : itype = NIOS16BF_INSN_ST8S16; goto extract_sfmt_st8s16;
          default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
          }
        }
      case 30 :
        {
          unsigned int val = (((insn >> 8) & (3 << 0)));
          switch (val)
          {
          case 0 : itype = NIOS16BF_INSN_SAVE16; goto extract_sfmt_save16;
          case 1 : itype = NIOS16BF_INSN_TRAP16; goto extract_sfmt_trap16;
          case 2 : itype = NIOS16BF_INSN_JMPC16; goto extract_sfmt_jmpc16;
          case 3 : itype = NIOS16BF_INSN_CALLC16; goto extract_sfmt_callc16;
          default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
          }
        }
      case 31 :
        {
          unsigned int val = (((insn >> 6) & (15 << 0)));
          switch (val)
          {
          case 0 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS16BF_INSN_NOT16; goto extract_sfmt_not16;
              case 1 : itype = NIOS16BF_INSN_NEG16; goto extract_sfmt_not16;
              default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 1 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS16BF_INSN_ABS16; goto extract_sfmt_not16;
              case 1 : itype = NIOS16BF_INSN_SEXT816; goto extract_sfmt_sext816;
              default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 2 : itype = NIOS16BF_INSN_RLC16; goto extract_sfmt_rrc16;
          case 3 : itype = NIOS16BF_INSN_RRC16; goto extract_sfmt_rrc16;
          case 6 : itype = NIOS16BF_INSN_RESTORE16; goto extract_sfmt_restore16;
          case 7 : itype = NIOS16BF_INSN_TRET16; goto extract_sfmt_tret16;
          case 8 : itype = NIOS16BF_INSN_ST8D16; goto extract_sfmt_st8d16;
          case 9 : itype = NIOS16BF_INSN_FILL816; goto extract_sfmt_fill816;
          case 11 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS16BF_INSN_SKPRZ16; goto extract_sfmt_skprz16;
              case 1 : itype = NIOS16BF_INSN_SKPS16; goto extract_sfmt_skps16;
              default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 12 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS16BF_INSN_WRCTL16; goto extract_sfmt_wrctl16;
              case 1 : itype = NIOS16BF_INSN_RDCTL16; goto extract_sfmt_rdctl16;
              default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          case 13 : itype = NIOS16BF_INSN_SKPRNZ16; goto extract_sfmt_skprz16;
          case 15 :
            {
              unsigned int val = (((insn >> 5) & (1 << 0)));
              switch (val)
              {
              case 0 : itype = NIOS16BF_INSN_JMP16; goto extract_sfmt_jmp16;
              case 1 : itype = NIOS16BF_INSN_CALL16; goto extract_sfmt_call16;
              default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
              }
            }
          default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
          }
        }
      case 32 : /* fall through */
      case 33 : itype = NIOS16BF_INSN_BR; goto extract_sfmt_br;
      case 34 : /* fall through */
      case 35 : itype = NIOS16BF_INSN_BSR16; goto extract_sfmt_bsr16;
      case 36 : /* fall through */
//      case 37 : itype = NIOS16BF_INSN_LDC16; goto extract_sfmt_ldc16;
      case 37 : itype = NIOS16BF_INSN_PFXIO; goto extract_sfmt_pfx;
      case 38 : /* fall through */
      case 39 : itype = NIOS16BF_INSN_PFX; goto extract_sfmt_pfx;
      case 40 : /* fall through */
      case 41 : /* fall through */
      case 42 : /* fall through */
      case 43 : itype = NIOS16BF_INSN_STP16; goto extract_sfmt_stp16;
      case 44 : /* fall through */
      case 45 : /* fall through */
      case 46 : /* fall through */
      case 47 : itype = NIOS16BF_INSN_LDP16; goto extract_sfmt_ldp16;
      case 48 : /* fall through */
      case 49 : /* fall through */
      case 50 : /* fall through */
      case 51 : /* fall through */
      case 52 : /* fall through */
      case 53 : /* fall through */
      case 54 : /* fall through */
      case 55 : itype = NIOS16BF_INSN_STS16; goto extract_sfmt_sts16;
      case 56 : /* fall through */
      case 57 : /* fall through */
      case 58 : /* fall through */
      case 59 : /* fall through */
      case 60 : /* fall through */
      case 61 : /* fall through */
      case 62 : /* fall through */
      case 63 : itype = NIOS16BF_INSN_LDS16; goto extract_sfmt_lds16;
      default : itype = NIOS16BF_INSN_X_INVALID; goto extract_sfmt_empty;
      }
    }
  }

  /* The instruction has been decoded, now extract the fields.  */

 extract_sfmt_empty:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_empty", (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_ext8s16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext8s16.f
    USI f_i1;
    UINT f_Ra;

    f_i1 = ((unsigned int) (EXTRACT_LSB0_UINT (insn, 16, 6, 2)) >> (1));
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i1) = f_i1;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ext8s16", "f_i1 0x%x", 'x', f_i1, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_st8s16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ext8s16.f
    USI f_i1;
    UINT f_Ra;

    f_i1 = ((unsigned int) (EXTRACT_LSB0_UINT (insn, 16, 6, 2)) >> (1));
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i1) = f_i1;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st8s16", "f_i1 0x%x", 'x', f_i1, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_sts8s16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_sts8s16.f
    UINT f_i10;

    f_i10 = EXTRACT_LSB0_UINT (insn, 16, 9, 10);

  /* Record the fields for the semantic handler.  */
  FLD (f_i10) = f_i10;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_sts8s16", "f_i10 0x%x", 'x', f_i10, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_st8d16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st8d16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_wrctl16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_wrctl16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_addc16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_addc16", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_add16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_add16", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_addi16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_addi16", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_or16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_or16.f
    UINT f_Rbi5;
    UINT f_Ra;

    f_Rbi5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Rbi5) = f_Rbi5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_or16", "f_Rbi5 0x%x", 'x', f_Rbi5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_lsl16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_lsl16", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_lsli16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_lsli16", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_not16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_not16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_mov16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Rb) = f_Rb;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_mov16", "f_Rb 0x%x", 'x', f_Rb, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_movi16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_movi16", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_bgen16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_bgen16", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_cmp16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_cmp16", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_cmpi16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_cmpi16", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_ldc16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldc16.f
    USI f_i6_rel_h;
    UINT f_Ra;

    f_i6_rel_h = ((((EXTRACT_LSB0_UINT (insn, 16, 10, 6)) << (1))) + (((((pc) & (131070))) + (4))));
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (i_m16_i6) = f_i6_rel_h;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ldc16", "f_Ra 0x%x", 'x', f_Ra, "m16_i6 0x%x", 'x', f_i6_rel_h, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_ext8d16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ext8d16", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_sext816:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_sext816", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_fill816:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_fill816", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_lds16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_i8;
    UINT f_Ra;

    f_i8 = EXTRACT_LSB0_UINT (insn, 16, 12, 8);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i8) = f_i8;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_lds16", "f_i8 0x%x", 'x', f_i8, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_sts16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_i8;
    UINT f_Ra;

    f_i8 = EXTRACT_LSB0_UINT (insn, 16, 12, 8);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i8) = f_i8;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_sts16", "f_i8 0x%x", 'x', f_i8, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_ldp16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_Rp;
    UINT f_i5;
    UINT f_Ra;

    f_Rp = EXTRACT_LSB0_UINT (insn, 16, 11, 2);
    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Rp) = f_Rp;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ldp16", "f_i5 0x%x", 'x', f_i5, "f_Rp 0x%x", 'x', f_Rp, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_stp16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_Rp;
    UINT f_i5;
    UINT f_Ra;

    f_Rp = EXTRACT_LSB0_UINT (insn, 16, 11, 2);
    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  FLD (f_Rp) = f_Rp;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_stp16", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, "f_Rp 0x%x", 'x', f_Rp, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_ld16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Rb) = f_Rb;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_ld16", "f_Rb 0x%x", 'x', f_Rb, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_st16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_addc16.f
    UINT f_Rb;
    UINT f_Ra;

    f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  FLD (f_Rb) = f_Rb;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_st16", "f_Ra 0x%x", 'x', f_Ra, "f_Rb 0x%x", 'x', f_Rb, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_trap16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_trap16.f
    UINT f_i6v;

    f_i6v = EXTRACT_LSB0_UINT (insn, 16, 5, 6);

  /* Record the fields for the semantic handler.  */
  FLD (f_i6v) = f_i6v;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_trap16", "f_i6v 0x%x", 'x', f_i6v, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_tret16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_tret16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_save16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_save16.f
    UINT f_i8v;

    f_i8v = EXTRACT_LSB0_UINT (insn, 16, 7, 8);

  /* Record the fields for the semantic handler.  */
  FLD (f_i8v) = f_i8v;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_save16", "f_i8v 0x%x", 'x', f_i8v, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_restore16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.fmt_empty.f


  /* Record the fields for the semantic handler.  */
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_restore16", (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_bsr16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_bsr16.f
    USI f_i11_rel;

    f_i11_rel = ((((((EXTRACT_LSB0_INT (insn, 16, 10, 11)) << (1))) + (pc))) + (2));

  /* Record the fields for the semantic handler.  */
  FLD (i_rel11) = f_i11_rel;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_bsr16", "rel11 0x%x", 'x', f_i11_rel, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_jmp16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_jmp16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_call16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_call16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_jmpc16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_jmpc16.f
    USI f_i8v_rel_h;

    f_i8v_rel_h = ((((EXTRACT_LSB0_UINT (insn, 16, 7, 8)) << (1))) + (((((pc) & (131070))) + (2))));

  /* Record the fields for the semantic handler.  */
  FLD (i_m16_i8v) = f_i8v_rel_h;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_jmpc16", "m16_i8v 0x%x", 'x', f_i8v_rel_h, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_callc16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_jmpc16.f
    USI f_i8v_rel_h;

    f_i8v_rel_h = ((((EXTRACT_LSB0_UINT (insn, 16, 7, 8)) << (1))) + (((((pc) & (131070))) + (2))));

  /* Record the fields for the semantic handler.  */
  FLD (i_m16_i8v) = f_i8v_rel_h;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_callc16", "m16_i8v 0x%x", 'x', f_i8v_rel_h, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_skp016:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_ldp16.f
    UINT f_i5;
    UINT f_Ra;

    f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5);
    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_i5) = f_i5;
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_skp016", "f_i5 0x%x", 'x', f_i5, "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_skprz16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_skprz16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_skps16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_skps16.f
    UINT f_i4w;

    f_i4w = EXTRACT_LSB0_UINT (insn, 16, 3, 4);

  /* Record the fields for the semantic handler.  */
  FLD (f_i4w) = f_i4w;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_skps16", "f_i4w 0x%x", 'x', f_i4w, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_rrc16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_rrc16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#undef FLD
    return idesc;
  }

 extract_sfmt_rdctl16:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_lds16.f
    UINT f_Ra;

    f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5);

  /* Record the fields for the semantic handler.  */
  FLD (f_Ra) = f_Ra;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_rdctl16", "f_Ra 0x%x", 'x', f_Ra, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_pfx:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_pfx.f
    UINT f_i11;

    f_i11 = EXTRACT_LSB0_UINT (insn, 16, 10, 11);

  /* Record the fields for the semantic handler.  */
  FLD (f_i11) = f_i11;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_pfx", "f_i11 0x%x", 'x', f_i11, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

 extract_sfmt_br:
  {
    const IDESC *idesc = &nios16bf_insn_data[itype];
    CGEN_INSN_INT insn = entire_insn;
#define FLD(f) abuf->fields.sfmt_bsr16.f
    USI f_i11_rel;

    f_i11_rel = ((((((EXTRACT_LSB0_INT (insn, 16, 10, 11)) << (1))) + (pc))) + (2));

  /* Record the fields for the semantic handler.  */
  FLD (i_rel11) = f_i11_rel;
  TRACE_EXTRACT (current_cpu, abuf, (current_cpu, pc, "sfmt_br", "rel11 0x%x", 'x', f_i11_rel, (char *) 0));

#if WITH_PROFILE_MODEL_P
  /* Record the fields for profiling.  */
  if (PROFILE_MODEL_P (current_cpu))
    {
    }
#endif
#undef FLD
    return idesc;
  }

}
