/* Decode header for nios32bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef NIOS32BF_DECODE_H
#define NIOS32BF_DECODE_H

extern const IDESC *nios32bf_decode (SIM_CPU *, IADDR,
                                  CGEN_INSN_INT, CGEN_INSN_INT,
                                  ARGBUF *);
extern void nios32bf_init_idesc_table (SIM_CPU *);
extern void nios32bf_sem_init_idesc_table (SIM_CPU *);
extern void nios32bf_semf_init_idesc_table (SIM_CPU *);

/* Enum declaration for instructions in cpu family nios32bf.  */
typedef enum nios32bf_insn_type {
  NIOS32BF_INSN_X_INVALID, NIOS32BF_INSN_X_AFTER, NIOS32BF_INSN_X_BEFORE, NIOS32BF_INSN_X_CTI_CHAIN
 , NIOS32BF_INSN_X_CHAIN, NIOS32BF_INSN_X_BEGIN, NIOS32BF_INSN_STS8S32, NIOS32BF_INSN_STS16S
 , NIOS32BF_INSN_MOVHI, NIOS32BF_INSN_EXT16D, NIOS32BF_INSN_SEXT16, NIOS32BF_INSN_ST16D
 , NIOS32BF_INSN_FILL16, NIOS32BF_INSN_EXT8S32, NIOS32BF_INSN_ST8S32, NIOS32BF_INSN_EXT16S
 , NIOS32BF_INSN_ST16S, NIOS32BF_INSN_ST8D32, NIOS32BF_INSN_WRCTL32, NIOS32BF_INSN_ADD32
 , NIOS32BF_INSN_SUB32, NIOS32BF_INSN_ADDI32, NIOS32BF_INSN_SUBI32, NIOS32BF_INSN_OR32
 , NIOS32BF_INSN_XOR32, NIOS32BF_INSN_AND32, NIOS32BF_INSN_ANDN32, NIOS32BF_INSN_LSL32
 , NIOS32BF_INSN_LSR32, NIOS32BF_INSN_ASR32, NIOS32BF_INSN_LSLI32, NIOS32BF_INSN_LSRI32
 , NIOS32BF_INSN_ASRI32, NIOS32BF_INSN_NOT32, NIOS32BF_INSN_NEG32, NIOS32BF_INSN_ABS32
 , NIOS32BF_INSN_MOV32, NIOS32BF_INSN_MOVI32, NIOS32BF_INSN_BGEN32, NIOS32BF_INSN_CMP32
 , NIOS32BF_INSN_CMPI32,                   NIOS32BF_INSN_EXT8D32, NIOS32BF_INSN_SEXT832
 , NIOS32BF_INSN_FILL832, NIOS32BF_INSN_LDS32, NIOS32BF_INSN_STS32, NIOS32BF_INSN_LDP32
 , NIOS32BF_INSN_STP32, NIOS32BF_INSN_LD32, NIOS32BF_INSN_ST32, NIOS32BF_INSN_TRAP32
 , NIOS32BF_INSN_TRET32, NIOS32BF_INSN_SAVE32, NIOS32BF_INSN_RESTORE32, NIOS32BF_INSN_BSR32
 , NIOS32BF_INSN_JMP32, NIOS32BF_INSN_CALL32, NIOS32BF_INSN_JMPC32, NIOS32BF_INSN_CALLC32
 , NIOS32BF_INSN_SKP032, NIOS32BF_INSN_SKP132, NIOS32BF_INSN_SKPRZ32, NIOS32BF_INSN_SKPRNZ32
 , NIOS32BF_INSN_SKPS32, NIOS32BF_INSN_RRC32, NIOS32BF_INSN_RLC32, NIOS32BF_INSN_RDCTL32
 , NIOS32BF_INSN_PFX, NIOS32BF_INSN_BR, NIOS32BF_INSN_PFXIO, NIOS32BF_INSN_MAX
} NIOS32BF_INSN_TYPE;

/* Enum declaration for semantic formats in cpu family nios32bf.  */
typedef enum nios32bf_sfmt_type {
  NIOS32BF_SFMT_EMPTY, NIOS32BF_SFMT_STS8S32, NIOS32BF_SFMT_STS16S, NIOS32BF_SFMT_MOVHI
 , NIOS32BF_SFMT_EXT16D, NIOS32BF_SFMT_SEXT16, NIOS32BF_SFMT_ST16D, NIOS32BF_SFMT_FILL16
 , NIOS32BF_SFMT_EXT8S32, NIOS32BF_SFMT_ST8S32, NIOS32BF_SFMT_EXT16S, NIOS32BF_SFMT_ST16S
 , NIOS32BF_SFMT_ST8D32, NIOS32BF_SFMT_WRCTL32, NIOS32BF_SFMT_ADD32, NIOS32BF_SFMT_ADDI32
 , NIOS32BF_SFMT_OR32, NIOS32BF_SFMT_LSL32, NIOS32BF_SFMT_LSLI32, NIOS32BF_SFMT_NOT32
 , NIOS32BF_SFMT_MOV32, NIOS32BF_SFMT_MOVI32, NIOS32BF_SFMT_BGEN32, NIOS32BF_SFMT_CMP32
 , NIOS32BF_SFMT_CMPI32,                     NIOS32BF_SFMT_LDS32, NIOS32BF_SFMT_STS32
 , NIOS32BF_SFMT_LDP32, NIOS32BF_SFMT_STP32, NIOS32BF_SFMT_LD32, NIOS32BF_SFMT_ST32
 , NIOS32BF_SFMT_TRAP32, NIOS32BF_SFMT_TRET32, NIOS32BF_SFMT_SAVE32, NIOS32BF_SFMT_RESTORE32
 , NIOS32BF_SFMT_BSR32, NIOS32BF_SFMT_JMP32, NIOS32BF_SFMT_CALL32, NIOS32BF_SFMT_JMPC32
 , NIOS32BF_SFMT_CALLC32, NIOS32BF_SFMT_SKP032, NIOS32BF_SFMT_SKPRZ32, NIOS32BF_SFMT_SKPS32
 , NIOS32BF_SFMT_RRC32, NIOS32BF_SFMT_RDCTL32, NIOS32BF_SFMT_PFX, NIOS32BF_SFMT_BR, NIOS32BF_SFMT_PFXIO
} NIOS32BF_SFMT_TYPE;

/* Function unit handlers (user written).  */

extern int nios32bf_model_nios32_1_u_exec (SIM_CPU *, const IDESC *, int /*unit_num*/, int /*referenced*/);

/* Profiling before/after handlers (user written) */

extern void nios32bf_model_insn_before (SIM_CPU *, int /*first_p*/);
extern void nios32bf_model_insn_after (SIM_CPU *, int /*last_p*/, int /*cycles*/);

#endif /* NIOS32BF_DECODE_H */
