/* nios16bf trap definitions
   Copyright (C) 1999 Cygnus Solutions.  */

#ifndef TRAP16_H
#define TRAP16_H

#include "trap.h"

void nios16bf_window_overflow (SIM_CPU *, IADDR pc_);
void nios16bf_window_underflow (SIM_CPU *, IADDR pc_);

void nios16bf_alloc_regwins (SIM_CPU *, int);
void nios16bf_free_regwins (SIM_CPU *);
void nios16bf_swapout_regwin (SIM_CPU *, int);
void nios16bf_swapin_regwin (SIM_CPU *, int);

void nios16bf_load_regwin (SIM_CPU *, IADDR pc_, int win_);
void nios16bf_flush_regwin (SIM_CPU *, IADDR pc_, int win_, int no_errors_p_);
void nios16bf_flush_regwins (SIM_CPU *, IADDR pc_, int no_errors_p_);

void nios16bf_save_regwin (SIM_CPU *);
void nios16bf_restore_regwin (SIM_CPU *);

void nios16bf_hw_trap (SIM_CPU *, IADDR pc_, TRAP_TYPE trap_);
IADDR nios16bf_sw_trap (SIM_CPU *, IADDR pc_, UQI i8v_ );

IADDR nios16bf_do_tret (SIM_CPU *, IADDR pc_, IADDR new_pc_);

#endif /* TRAP16_H */
