/* nios32bf trap definitions
   Copyright (C) 1999 Cygnus Solutions.  */

#ifndef TRAP32_H
#define TRAP32_H

#include "trap.h"

void nios32bf_window_overflow (SIM_CPU *, IADDR pc_);
void nios32bf_window_underflow (SIM_CPU *, IADDR pc_);

void nios32bf_alloc_regwins (SIM_CPU *, int);
void nios32bf_free_regwins (SIM_CPU *);
void nios32bf_swapout_regwin (SIM_CPU *, int);
void nios32bf_swapin_regwin (SIM_CPU *, int);

void nios32bf_load_regwin (SIM_CPU *, IADDR pc_, int win_);
void nios32bf_flush_regwin (SIM_CPU *, IADDR pc_, int win_, int no_errors_p_);
void nios32bf_flush_regwins (SIM_CPU *, IADDR pc_, int no_errors_p_);

void nios32bf_save_regwin (SIM_CPU *);
void nios32bf_restore_regwin (SIM_CPU *);

void nios32bf_hw_trap (SIM_CPU *, IADDR pc_, TRAP_TYPE trap_);
IADDR nios32bf_sw_trap (SIM_CPU *, IADDR pc_, UQI i8v_ );

IADDR nios32bf_do_tret (SIM_CPU *, IADDR pc_, IADDR new_pc_);

#endif /* TRAP32_H */
